#!/usr/bin/python
# -*- coding: utf-8 -*-

import sys

reload(sys)
sys.setdefaultencoding('utf8')

import os
import dbus
import dbus.service
import traceback
from PyQt4.QtGui import *
from PyQt4.QtCore import *
from service.dbus_service import DbusService
from service.kylin_update_service import KylinUpdateService
from utils.enums import LaunchMode, TaskMode, LWMode, AUPSource, AppType, AppMsg, Signals, LOADINGWIDTH, LOADINGHEIGHT, \
    MAINWIDTH, MAINHEIGHT, DETAILWIDTH, DETAILHEIGHT, SINTERFACE, SINTERFACES, RUNLIST,SPHEIGHT,SPWIDTH
from utils.common_utils import CommonUtils
from utils.util_dbus import UtilDbus
from utils.log_manager import LogManager
from utils import log_manager
from mainui.updatelistitemwidget import UpdateListItemWidget
from mainui.messagewidget import MessageWidget
from mainui.loadingwidget import LoadingWidget
from mainui.topwidget import TopWidget
from mainui.bottomwidget import BottomWidget
from mainui.detailwidget import DetailWidget
from mainui.system_tray import SystemTray
from mainui.confwidget import ConfigWidget
from mainui.menubar import menubar
from mainui.downloadwidget import *
from mainui.update_success_widget import *
from mainui.titlebar import *
from mainui.appdetails import *


import urllib
import urllib2
import socket
import time
import uuid

import locale
import gettext

locale.setlocale(locale.LC_ALL, "")
gettext.bindtextdomain("kylin-update-manager", "/usr/share/locale")
gettext.textdomain("kylin-update-manager")
_ = gettext.gettext

PINGBACK_URL = "http://archive.kylinos-intranet.cn/kylin-update-manager-server/main.php"
PKGLIST = []

#类：用于进行main_work，由于进行外网源配置时时间太长到时线程任然会阻塞界面
class Thread_work(QThread):
    def __init__(self,parent=None):
        QThread.__init__(self)
        self.parent = parent

    def run(self):
        self.parent.main_work()
class Thread_check_update(QThread):
    def __init__(self,parent=None):
        QThread.__init__(self)
        self.parent = parent

    def run(self):
        self.parent.kus.start_access()

class MainWindow(QWidget):
    service_key = ""
    hash_pwd = ""
    item_map_ordinary = {}
    item_map_important = {}
    item_map = {}
    item_num = 0
    get_app_num=0
    update_item_map = {}

    size_ordinary = 0
    size_important = 0
    app_num_ordinary = 0
    app_num_important = 0
    selected_num_ordinary = 0
    selected_num_important = 0

    available_source = AUPSource.NOSOURCE
    is_log_init = False
    is_working = False
    is_working_c = False
    is_error = False
    is_conffile = False
    launch_mode = None
    task_mode = None
    is_sp_update = False
    is_created = False

    click_config = False
    click_cancel = False

    iface = None
    kus = None
    cu = None

    App_Version_list = []
    App_install_num = 0

    previous_process_type = ""
    work_list=[]
    crucial_list=[]

    get_pos = pyqtSignal()
    signal_show_exit = pyqtSignal(str)
    change_loading_tiplabel = pyqtSignal(str,bool)
    kum_update_finish = pyqtSignal()
    clean_sp_widget = pyqtSignal()

    down_num = 0
    down_done = 0

    install_num = 0
    install_stop = 0
    installed_app_num = 0

    down_item = None
    install_item = None

    timer = QTimer()
    sp_timer = QTimer()
    exit_time = QTimer()
    error_time = QTimer()
    kum_time = QTimer()

    firsttime_click_item = True

    def __init__(self, launch_mode, parent=None):
        QWidget.__init__(self, parent)

        # 设置全局异常处理函数
        sys.excepthook = self.global_except_hook

        self.launch_mode = launch_mode

        self.init_log()
        self.init_ui()
        self.check_singleton()
        self.cu = CommonUtils()
        self.check_service_key()
        self.iface = DbusService()
        self.kus = KylinUpdateService(self)
        self.init_main_animation()
        self.init_connect()
        #self.pre_work()

    #
    # 函数：全局异常捕获
    # etype：异常类型
    # value：异常值
    # trace：堆栈信息
    #
    def global_except_hook(self, etype, value, trace):
        msg = traceback.format_exception(etype, value, trace)
        if self.is_log_init == True:
            LogManager.CRI("".join(msg))

        sys.__excepthook__(etype, value, trace)
        # self.exit_app("程序异常退出！详情见 $HOME/.cache/kum.log")
        self.exit_app(_("Crashed! For details in $HOME/.cache/kum.log"))

    #
    # 函数：初始化UI
    #
    def init_ui(self):
        self.setWindowIcon(QIcon("./res/kylin-update-manager.png"))
        self.setWindowTitle(_("Kylin Update Manager"))
        self.setWindowOpacity(1)
        self.setFocusPolicy(Qt.NoFocus)
        self.resize(LOADINGWIDTH,LOADINGHEIGHT)
        '''
        # 实例阴影shadow
        shadow = QGraphicsDropShadowEffect(self)
        # 设置阴影距离
        shadow.setOffset(0, 0)
        # 设置阴影颜色
        shadow.setColor(QColor("#888888"))
        # 设置阴影圆角
        shadow.setBlurRadius(6)
        # 给嵌套QWidget设置阴影
        self.widget.setGraphicsEffect(shadow)
        # 给垂直布局器设置边距(此步很重要, 设置宽度为阴影的宽度)
        '''
        self.setAutoFillBackground(True)
        #self.setAttribute(Qt.WA_TranslucentBackground)
        self.setWindowFlags(Qt.FramelessWindowHint | Qt.Widget)
        #self.setAttribute(Qt.WA_TranslucentBackground)
        palette = QPalette()
        palette.setColor(QPalette.Background, QColor(255, 255, 255))  # eaf0f3
        self.setPalette(palette)
        #self.title_widget =  TitleBar(self.width(),True,True, _("Kylin Update Manager"),self)
        self.bottom_widget = BottomWidget(False,self)
        self.bottom_widget.hide()
        self.update_bottom_widget=BottomWidget(True,self)
        self.update_bottom_widget.setGeometry(0,60,self.update_bottom_widget.width(),self.update_bottom_widget.height())
        self.update_bottom_widget.hide()
        self.detail_widget = DetailWidget(self)
        self.detail_widget.hide()
        self.titlebar = TitleBar(self.width(),True,True, _("Kylin Update Manager")+VERSION,self)

        self.titlebar.setGeometry(0,0,self.titlebar.width(),self.titlebar.height())
        self.titlebar.show()
        self.loading_widget = LoadingWidget(self)
        self.loading_widget.setGeometry(0,40,550,280)
        #self.quit_widget = LoadingWidget(self)
        #self.loading_widget.setStyleSheet("QWidget{border-radius:6px;border:1px solid #cfcfcf;}")

        self.update_succuss_widget = UpdateSuccessWidget(self)
        self.update_succuss_widget.hide()
        self.mouse_press = False
        # self.animation_msg_box = MessageWidget("发现需要更新的软件。", False)
        self.animation_msg_box = MessageWidget(_("Updated software is available for this computer."), False)
        self.resize(0, 0)
        self.move_to_center()
        self.show()

        if (self.launch_mode == LaunchMode.MANUAL):
            self.resize(LOADINGWIDTH, LOADINGHEIGHT)
            self.loading_widget.progressBar.hide()
            self.loading_widget.loadinglabel.show()
            self.show_main_window()
        if (self.launch_mode == LaunchMode.AUTOMATIC):
            self.setWindowFlags(Qt.FramelessWindowHint |Qt.WindowStaysOnTopHint)
            self.resize(LOADINGWIDTH,LOADINGHEIGHT)
            self.loading_widget.progressBar.hide()
            self.loading_widget.loadinglabel.show()
            self.loading_widget.hide()
            self.move_to_center()
            self.hide()

    '''def paintEvent(self,event):
        painter=QPainter(self)
        painter.setRenderHint(QPainter.Antialiasing)
        painter.setBrush(QBrush(Qt.white))
        painter.setPen(Qt.transparent)
        rect = self.rect()
        rect.setWidth(rect.width())
        rect.setHeight(rect.height())
        painter.drawRoundedRect(rect, 6, 6)'''

    #
    # 函数：初始化动画效果
    #
    def init_main_animation(self):

        '''
        topAnimation = QPropertyAnimation(self.title_widget, "pos")
        topAnimation.setDuration(1000)
        topAnimation.setStartValue(QPoint(0,-114))
        topAnimation.setEndValue(QPoint(0,0))
        '''


        bottomAnimation = QPropertyAnimation(self.bottom_widget, "pos")
        bottomAnimation.setDuration(1000)
        bottomAnimation.setStartValue(QPoint(0,620))
        bottomAnimation.setEndValue(QPoint(0,60))

        '''
        updatetopOrigAnimation = QPropertyAnimation(self.update_top_widget, "pos")
        updatetopOrigAnimation.setDuration(1000)
        updatetopOrigAnimation.setStartValue(QPoint(0, 0))
        updatetopOrigAnimation.setEndValue(QPoint(0, -141))
        '''


        updatebottomOrigAnimation = QPropertyAnimation(self.update_bottom_widget, "pos")
        updatebottomOrigAnimation.setDuration(1000)
        updatebottomOrigAnimation.setStartValue(QPoint(0, 60))
        updatebottomOrigAnimation.setEndValue(QPoint(0, 620))

        self.loadingAnimation = QPropertyAnimation(self.loading_widget, "size")
        self.loadingAnimation.setDuration(1000)
        self.loadingAnimation.setStartValue(QSize(self.loading_widget.width(),self.loading_widget.height()))
        self.loadingAnimation.setEndValue(QSize(0,0))

        self.mainGroup = QParallelAnimationGroup()
        #self.mainGroup.addAnimation(topAnimation)
        self.mainGroup.addAnimation(bottomAnimation)
        #self.mainGroup.addAnimation(updatetopOrigAnimation)
        #self.mainGroup.addAnimation(updatebottomOrigAnimation)
        #self.mainGroup.addAnimation(loadingAnimation)


        bottomOrigAnimation = QPropertyAnimation(self.bottom_widget, "pos")
        bottomOrigAnimation.setDuration(1000)
        bottomOrigAnimation.setStartValue(QPoint(0, 60))
        bottomOrigAnimation.setEndValue(QPoint(0, 620))

        updatebottomAnimation = QPropertyAnimation(self.update_bottom_widget, "pos")
        updatebottomAnimation.setDuration(1000)
        updatebottomAnimation.setStartValue(QPoint(0, 620))
        updatebottomAnimation.setEndValue(QPoint(0, 60))

        self.updateGroup = QParallelAnimationGroup(self)
        self.updateGroup.addAnimation(bottomOrigAnimation)
        self.updateGroup.addAnimation(updatebottomAnimation)
        #self.updateGroup.addAnimation(loadingAnimation)

        detailOrigAnimation = QPropertyAnimation(self.detail_widget, "pos")
        detailOrigAnimation.setDuration(1000)
        detailOrigAnimation.setStartValue(QPoint(-336, 0))
        detailOrigAnimation.setEndValue(QPoint(0, 0))

        self.detailGroup = QParallelAnimationGroup(self)
        self.detailGroup.addAnimation(bottomOrigAnimation)
        self.detailGroup.addAnimation(detailOrigAnimation)

    #
    # 函数：信号槽绑定
    #
    def init_connect(self):
        #self.title_widget.close_button.clicked.connect(self.slot_click_close_button)
        #self.title_widget.min_button.clicked.connect(self.slot_click_min_button)
        #self.title_widget.set_button.clicked.connect(self.slot_click_menu_button)
        self.loading_widget.cancel_btn.clicked.connect(self.exit_app)
        self.loading_widget.continue_btn.clicked.connect(self.slot_continue_scan)
        self.titlebar.close_button.clicked.connect(self.slot_click_close_button)
        self.titlebar.min_button.clicked.connect(self.slot_click_min_button)
        self.titlebar.set_button.clicked.connect(self.slot_click_menu_button)
        self.bottom_widget.lw_all_selection.itemClicked.connect(self.slot_click_update_item)
        self.bottom_widget.sp_selection.itemClicked.connect(self.slot_click_sp_update_item)
        self.bottom_widget.click_ordinary_main_cb.connect(self.slot_reset_ordinary_cb)
        self.bottom_widget.click_important_main_cb.connect(self.slot_reset_important_cb)
        self.bottom_widget.click_main_cb.connect(self.slot_reset_cb)
        self.bottom_widget.layout_all_cb.label_update.clicked.connect(self.slot_click_install_button)
        self.bottom_widget.layout_all_cb.label_cancel.clicked.connect(self.slot_click_cancel_button)
        self.detail_widget.title_bar.min_button.clicked.connect(self.slot_click_min_button)
        self.detail_widget.title_bar.close_button.clicked.connect(self.slot_click_close_button)
        self.update_succuss_widget.close_btn.clicked.connect(self.slot_click_tip_close_button)
        self.animation_msg_box.quitSignal.connect(self.exit_app)
        self.connect(self.iface, Signals.dbus_process_msg, self.slot_dbus_process_msg)

        self.iface.down_pulse.connect(self.slot_down_start)
        self.iface.down_finish.connect(self.slot_down_finish)
        self.iface.apt_start.connect(self.slot_apt_start)
        self.iface.apt_finish.connect(self.slot_apt_finish)

        self.timer.timeout.connect(self.slot_timeout)
        self.sp_timer.timeout.connect(self.slot_sptimer_timeout)
        self.exit_time.timeout.connect(self.exit_app)
        self.kum_time.timeout.connect(self.slot_kum_finish_tiomeout)

        self.signal_show_exit.connect(self.show_exit_widget)
        self.change_loading_tiplabel.connect(self.slot_change_tiplabel)
        self.kum_update_finish.connect(self.slot_kum_update_finish)
        self.clean_sp_widget.connect(self.slot_clean_spwidget)


    #
    # 函数：初始化日志模块
    #
    def init_log(self):
        # log_manager.init_log()
        self.is_log_init = True

    #
    # 函数：保证单例模式
    #
    def check_singleton(self):
        try:
            bus = dbus.SessionBus()
        except:
            LogManager.CRI(_("Dbus Initialize Failed, Program Quit."))
            sys.exit(0)

        # 已有实例在运行，将其显示到前端
        try:
            proxy_obj = bus.get_object(SINTERFACE, SINTERFACES)
            iface = dbus.Interface(proxy_obj, SINTERFACE)
            iface.bring_to_front()
            # 退出重复运行的当前实例
            sys.exit(0)

        # 没有实例在运行，创建一个dbus
        except dbus.DBusException:
            bus_name = dbus.service.BusName(SINTERFACE, bus)
            self.dbusControler = UtilDbus(self, bus_name)

    #
    # 函数：获取麒麟操作系统服务序列号
    #
    def check_service_key(self):
        if (self.cu.is_os_community() == True):
            self.service_key = "kylin"
            self.hash_pwd = "123123"
        else:
            print(_("Geting Service Serial Number..."))
            self.service_key = self.cu.get_service_key()
            self.hash_pwd = self.cu.get_hash_pwd()

            if self.service_key is None:
                LogManager.ERR(_("Get Service Serial Number Failed, Program Quit!"))
                if (self.launch_mode == LaunchMode.AUTOMATIC):
                    self.exit_app(_("Get Service Serial Number Failed, Program Quit!"))
                else:
                    qb = QMessageBox(self)
                    qb.setIcon(QMessageBox.Question)
                    qb.setWindowTitle("授权文件异常")
                    # qb.setText("当前连接的服务器或光盘中没有完全匹配的软件源。\n是否选择其中的默认软件源进行升级？\n\n这可能会导致未知的后果，请向技服人员确认。")
                    qb.setText(_("Get Service Serial Number Failed, Program Quit!"))
                    qb.setStandardButtons(QMessageBox.Yes)
                    qb.setButtonText(QMessageBox.Yes, QString(_("OK")))
                    rtn = qb.exec_()
                    self.exit_app(_("Get Service Serial Number Failed, Program Quit!"))


    #
    # 函数：收集客户端信息发送给php服务器
    #
    def pingback(self):
        host_ip, version, soft_version, host_mac = '', '', '', ''
        # 获取本机ip
        try:
            s = socket.socket(socket.AF_INET, socket.SOCK_DGRAM)
            s.connect(('8.8.8.8', 80))
            host_ip = s.getsockname()[0]
        except:
            host_ip = 'Ip failed to get'
        # 获取系统版本
        with open('/etc/lsb-release', 'r') as f:
            for line in f:
                if line.strip().startswith('DISTRIB_KYLIN_RELEASE='):
                    version = line.strip().split('=')
                    version = version[1]
        # 获取软件版本
        output = os.popen('dpkg -l|grep kylin-update-m').readlines()
        if output:
            soft_version = output[0].strip().split()
            soft_version = soft_version[2]

        # 获取时间
        nowtime = time.strftime('%Y-%m-%d %H:%M:%S', time.localtime(time.time()))

        # 获取Mac
        mac = uuid.UUID(int=uuid.getnode()).hex[-12:]
        host_mac = ":".join([mac[e:e + 2] for e in range(0, 11, 2)])

        send_data = {'ip': host_ip, 'version': version, 'soft_version': soft_version, 'datetime': nowtime,
                     'host_mac': host_mac}
        send_data_urlencode = urllib.urlencode(send_data)
        requrl = PINGBACK_URL

        try:
            req = urllib2.Request(url=requrl, data=send_data_urlencode)
            res_ddd = urllib2.urlopen(req)
        except Exception, e:
            print(_("Pingback failed."), e)

    #
    # 函数：准备工作
    #
    def pre_work(self):
        # 修复可能出现的dpkg问题，卸载可能存在的SP升级包，完成后由slot_dbus_process_msg() 执行 main_work()
        print(_("executing dpkg configure."))
        self.iface.call_configure_dpkg_by_shell()


    #
    # 函数：主流程
    #
    def main_work(self):
        self.pingback()
        if (self.kus.check_available_medium() == True):
            if (self.kus.is_sinfo_down_success == True):
                if (self.kus.is_sinfo_match == True):
                    self.check_status()
                else:
                    qb = QMessageBox(self)
                    qb.setIcon(QMessageBox.Question)
                    # qb.setWindowTitle("没有匹配的源")
                    qb.setWindowTitle(_("No Matching Source"))
                    # qb.setText("当前连接的服务器或光盘中没有完全匹配的软件源。\n是否选择其中的默认软件源进行升级？\n\n这可能会导致未知的后果，请向技服人员确认。")
                    qb.setText(_(
                        "The connected server or CD does not have matched software source.\nDo you want to select the default software source to upgrade?\n\nThe operation may cause unknow result, please confirm to technocrat."))
                    qb.setStandardButtons(QMessageBox.Yes | QMessageBox.No)
                    qb.setButtonText(QMessageBox.Yes, QString(_("OK")))
                    qb.setButtonText(QMessageBox.No, QString(_("Cancel")))
                    rtn = qb.exec_()

                    if (rtn == QMessageBox.Yes):
                        self.check_status()
                    else:
                        self.set_default_sourceslist()
                        self.exit_app(_("User Cancel, Program Quit."))

            # 下载sinfo失败
            else:
                self.set_default_sourceslist()

                if (self.kus.is_sinfo_match == False):
                    if (self.launch_mode == LaunchMode.AUTOMATIC):
                        # self.exit_app("媒介中没有可用的软件源，程序退出.")
                        self.exit_app(_("No software source available, Program Quit."))
                    else:
                        # self.animation_msg_box.set_animation_args("媒介中没有可用的软件源，程序退出", True)
                        #self.show_exit_widget(_("No software source available"))
                        #self.signal_show_exit.emit(_("No software source available"))
                        self.loading_widget.change_layout.emit(_("No software source available"))
                else:
                    if (self.launch_mode == LaunchMode.AUTOMATIC):
                        # self.exit_app("下载软件源信息出错，程序退出.")
                        self.exit_app(_("Error when downloading info of software source, Program Quit."))
                    else:
                        #self.animation_msg_box.showAnimation(5000)
                        #self.show_exit_widget(_("Error when downloading info of software source"))
                        self.signal_show_exit.emit(_("Error when downloading info of software source"))

        # 找不到可用的升级媒介
        else:
            self.set_default_sourceslist()

            if (self.launch_mode == LaunchMode.AUTOMATIC):
                # self.exit_app("没有可用的升级媒介，程序退出.")
                self.exit_app(_("No upgrade media available, Program Quit."))
            else:
                #self.animation_msg_box.showAnimation(5000)
                #self.show_exit_widget(_("No upgrade media available"))
                self.signal_show_exit.emit(_("No upgrade media available"))

    #
    # 函数：检测apt update、自我升级、系统升级
    #
    def check_status(self):
        # 修改sourceslist
        self.available_source = self.kus.available_source
        try:
            lines = self.kus.get_sources()
            self.iface.change_source_list_to_kylin_update(lines)
        except:
            if self.launch_mode == LaunchMode.AUTOMATIC:
                self.exit_app("")
            #self.show_exit_widget(_("Missing sinfo file"))
            self.signal_show_exit.emit(_("Missing sinfo file"))

        try:
            # 需要apt-get update
            if (self.kus.check_need_apt_get_update() == True):
                # 执行apt-get update，False代表完成后由slot_dbus_process_msg() 执行 check_update_type()
                self.iface.call_update_source_by_shell(False)

            else:
                self.kus.check_update_type()
        except:
            if self.launch_mode == LaunchMode.AUTOMATIC:
                self.exit_app()
            #self.show_exit_widget(_("Missing sinfo file"))
            self.signal_show_exit.emit(_("Missing sinfo file"))

    #
    # 函数：任务分支
    #
    def switch_task(self, is_kylin_update, is_kum_update):
        # 可能的apt-get update已完成，告知dbus后台初始化apt库

        self.iface.call_init_cache()
        if self.is_created == False:
        # pyqt缺陷，密集执行函数时初始化trayicon很容易导致trayicon大小异常
        # 不得已将trayicon的初始化放此处，在大部分任务处理完之后
            self.tray_icon = SystemTray(self)
            self.is_created = True

        if (is_kum_update == True):
            self.task_mode = TaskMode.UPDATEKUM
        else:
            if (is_kylin_update == True):
                self.task_mode = TaskMode.UPDATEOS
            else:
                self.task_mode = TaskMode.UPDATEPKG

        # 更新管理器自我升级流程
        if (self.task_mode == TaskMode.UPDATEKUM):
            # self.tray_icon.start_tray_msg("正在升级更新管理器.")
            #self.tray_icon.start_tray_msg(_("Upgrading Update Manager."))
            self.change_loading_tiplabel.emit(_("Detected"),True)
            self.is_working_c = True
            self.iface.call_upone("kylin-update-manager")

        # 系统升级流程
        elif (self.task_mode == TaskMode.UPDATEOS):
            # 提示进行系统升级
            self.show_main_window()
        # 包升级流程
        else:
            self.kus.start_access()

    #
    #函数：显示自我升级
    #
    def slot_kum_update_finish(self):
        self.loading_widget.loadinglabel.hide()
        self.loading_widget.appname_label.hide()
        self.loading_widget.label1.hide()
        self.loading_widget.update_tip.show()
        self.loading_widget.update_tip.setText(_("Update Succesed."))
        self.loading_widget.tiplabel.setText(_("Automatically restart the update manager in three seconds"))

    #
    # 函数：自我升级完成，退出dbus，重启更新管理器
    #
    def kylin_update_manager_upgrade_finish(self):
        self.kum_update_finish.emit()
        self.kum_time.start(3000)

    #
    #函数：重启更新管理器
    #
    def slot_kum_finish_tiomeout(self):
        self.kum_time.stop()
        if self.iface:
            self.iface.exit_dbus()

        if self.launch_mode == LaunchMode.AUTOMATIC:
            os.system("kylin-update-manager-restart -auto &")
        else:
            os.system("kylin-update-manager-restart -m &")

        self.close()
        sys.exit("Update Manager Restart.")

    #
    # 函数：修复配置文件冲突，默认选择Yes
    #
    def fix_conffile(self):
        print(_("fixing conffile."))
        self.iface.call_fix_conffile()

    #
    # 函数：安装kylin-update完成，执行并退出更新管理器
    #
    def kylin_update_install_finish(self):
        if os.path.isfile("/usr/share/kylin-update-desktop/kylin-simpleupdate"):
            os.system("/usr/share/kylin-update-desktop/kylin-simpleupdate &")
        elif os.path.isfile("/tmp/kylin-update/kylin-simpleupdate"):
            os.system("/tmp/kylin-update/kylin-simpleupdate &")
        self.exit_app(_("System upgrade start, Update Manager Quit."))

    #
    # 函数：软件安装完成后，需要拉起的软件运行其启动命令
    #
    def run_software(self):
        for line in RUNLIST:
            run_command = line + " &"
            os.system(run_command)
        self.exit_app(_("Update succeed..."))

    #
    # 函数：将sources.list.kumbak还原为sources.list
    #
    def set_default_sourceslist(self):
        print "# restore /etc/apt/sources.list and do apt-get update"
        self.iface.change_source_list_to_default()
        # self.iface.call_update_source_by_shell(True)#lixiang

    '''
    Dbus Apt后台信号统一处理函数
    信号传递顺序：
    daemon.kum_fetch_signal() / kum_apt_signal()
    dbus_service.slot_kum_fetch_signal() / slot_kum_apt_signal()
    self.slot_dbus_process_msg()
    '''

    def slot_dbus_process_msg(self, signal_type, app_name, action, percent, process_type, status):
        print app_name, " : ", signal_type, " : ", process_type, " : ", str(percent), " : ", status, " : ", action

        # conffile冲突
        if process_type == "apt_conffile":
            self.is_conffile = True

        # 错误信号,有conffile时暂不处理
        if process_type == "apt_error" and self.is_conffile == False:
            self.set_default_sourceslist()
            self.is_working = False
            self.is_error = True
            if app_name == "#update" or app_name == "#update-shell":
                # self.animation_msg_box.set_animation_args("源更新失败，程序将在5秒后退出.", True)
                LogManager.INFO(_("Update source failed, five seconds later, Program will quit."))
                #self.show_exit_widget(_("Update source failed"))
                self.signal_show_exit.emit(_("Update source failed"))

            else:
                # 有包无法下载
                if (str(percent) == "-99.0"):
                    msgToShow = status + " " + _("Update software failed, five seconds later, Program will quit.")
                    LogManager.INFO(msgToShow)
                    #self.show_exit_widget(_("Update software failed"))
                    self.signal_show_exit.emit(_("Update software failed"))

                else:
                    # 升级流程时出错,自动退出.
                    if (self.task_mode == TaskMode.UPDATEOS):
                        # self.animation_msg_box.set_animation_args("SP补丁更新错误，程序将在5秒后退出.", True)
                        LogManager.INFO(_("Update service pack failed, five seconds later, Program will quit."))
                        #self.show_exit_widget(_("Update service pack failed"))
                        self.signal_show_exit.emit(_("Update service pack failed"))
                    else:
                        # self.animation_msg_box.set_animation_args("软件更新失败，程序将在5秒后退出.", True)
                        LogManager.INFO(_("Update software failed, five seconds later, Program will quit."))
                        #self.show_exit_widget(_("Update software failed"))
                        self.signal_show_exit.emit(_("Update software failed"))

        # 调用本地命令dpkg --configure -a过程的信号
        if app_name == "#configure-shell":
            if process_type == "finish" and str(percent) == "200.0":
                # dpkg --configure -a完成，开始执行main work
                # self.loading_widget.tiplabel.setText("正在从源中更新数据...")
                #self.loading_widget.tiplabel.setText(_("Updating data from source..."))
                self.change_loading_tiplabel.emit(_("Updating data from source..."),False)
                self.thread_work = Thread_work(self)
                self.thread_work.start()
                #self.main_work()

        # 调用本地命令apt-get update过程的信号
        if app_name == "#update-shell":
            if process_type == "finish" and str(percent) == "200.0":
                print "!!  一次apt-get update完成，模式：", action
                # 0既传入的False，代表非quiet，开始检测是否有系统版本升级
                if action == "0":
                    self.kus.check_update_type()

        # 更新管理器自我升级的信号，kylin-update-manager包安装完成，重启自身和dbus后台
        if app_name == "kylin-update-manager":
            if process_type == "apt_finish" and str(percent) == "100.0":
                for i in self.App_Version_list:
                    if i["name"] == app_name:
                        LogManager.INSTALL(("installed " + app_name + ' ' + i['version']))

                self.kylin_update_manager_upgrade_finish()

        # 系统升级流程的信号，kylin-update包安装完成，执行系统升级
        if app_name == "kylin-update-desktop" or app_name == "kylin-update-server":
            if process_type == "apt_finish" and str(percent) == "100.0":
                for i in self.App_Version_list:
                    if i["name"] == app_name:
                        LogManager.INSTALL(("installed " + app_name + ' ' + i['version']))

                self.kylin_update_install_finish()

        # 调用本地命令fix conffile过程的信号
        if app_name == "#fix-conffile-shell":
            if self.is_working_c == True:
                LogManager.INFO(_("Crucial update successed..."))
                self.is_working_c = False
                self.detail_widget.pb_fetch.setValue(0)
                self.detail_widget.pb_apt.setValue(0)
                self.update_bottom_widget.te_description.clear()
                self.tray_icon.hide()

                if self.isHidden() == True:
                    self.set_default_sourceslist()
                    #self.show_exit_widget(_("Update Succesed."))
                    self.signal_show_exit.emit(_("Update Succesed."))
            else:
                LogManager.INFO(_("Ordinary and Important update successed..."))
                self.is_working = False
                self.detail_widget.pb_apt.setValue(100)
                self.update_bottom_widget.te_description.append(_("Update Succesed."))
                self.set_default_sourceslist()
                #self.animation_msg_box.set_animation_args(_("Update succeed, five seconds later, Program will quit."),True)
                #self.animation_msg_box.showAnimation(5000)
                #self.show_exit_widget(_("Update Succesed."))
                self.signal_show_exit.emit(_("Update Succesed."))
        # 包升级过程的信号
        else:
            # 下载过程
            if  signal_type == "fetch":
                if process_type == "down_start":
                    # self.detail_widget.te_detail.append("开始下载.")
                    #self.update_bottom_widget.te_description.append(_("Start Download."))
                    self.detail_widget.pb_fetch.setValue(0)
                elif process_type == "down_stop":
                    # self.detail_widget.te_detail.append("下载完成，准备安装.")
                    #self.update_bottom_widget.te_description.append(_("Download complete, Ready to install."))
                    self.detail_widget.pb_fetch.setValue(100)
                else:
                    if "down_pulse" in process_type:
                        # apt会重复打印信息，过滤掉
                        if process_type != self.previous_process_type:
                            self.previous_process_type = process_type
                            #self.update_bottom_widget.te_description.append(process_type.split(" ")[1])
                    if percent not in [0.0, "0.0", None]:
                        self.detail_widget.pb_fetch.setValue(int(percent))
                        self.tray_icon.process_now = str(int(percent) / 2)

            # 安装过程
            elif signal_type == "apt" and process_type == "apt_start":
                self.detail_widget.pb_apt.setValue(0)
                #self.update_bottom_widget.te_description.append(status)
                #self.update_bottom_widget.te_description.append(_("Installing..."))


            # 安装结束
            elif app_name == "#install_and_upgrade" and signal_type == "apt" and process_type == "apt_finish" and self.is_error == False:
                for pkg in PKGLIST:
                    for i in self.App_Version_list:
                        if i["name"] == pkg:
                            LogManager.INSTALL(("installed " + pkg + ' ' + i['version']))

                if self.is_conffile == True:
                    self.fix_conffile()
                else:
                    if self.is_working_c == True:
                        LogManager.INFO(_("Crucial update successed..."))
                        self.is_working_c = False
                        self.detail_widget.pb_fetch.setValue(0)
                        self.detail_widget.pb_apt.setValue(0)
                        #self.update_bottom_widget.te_description.clear()
                        self.tray_icon.hide()

                        if self.isHidden() == True:
                            self.set_default_sourceslist()
                            if RUNLIST:
                                self.run_software()
                            #self.animation_msg_box.set_animation_args( _("Update succeed, five seconds later, Program will quit."), True)
                            #self.animation_msg_box.showAnimation(5000)
                            #self.show_exit_widget(_("Update Succesed."))
                            self.signal_show_exit.emit(_("Update Succesed."))
                    else:
                        LogManager.INFO(_("Ordinary and Important update successed..."))
                        self.is_working = False
                        self.detail_widget.pb_apt.setValue(100)
                        #self.update_bottom_widget.te_description.append(_("Update Succesed."))
                        self.set_default_sourceslist()
                        if RUNLIST:
                            self.run_software()
                        #self.animation_msg_box.set_animation_args(_("Update succeed, five seconds later, Program will quit."), True)
                        #self.animation_msg_box.showAnimation(5000)
                        #self.show_exit_widget(_("Update Succesed."))
                        self.signal_show_exit.emit(_("Update Succesed."))


            # 流程pulse
            else:
                if signal_type == "apt" and process_type == "apt_pulse":
                    if (app_name not in PKGLIST) and (app_name not in ("dpkg-exec", "fontconfig", "dbus")):
                        PKGLIST.append(app_name)
                    self.detail_widget.pb_apt.setValue(int(percent))
                    self.tray_icon.process_now = str(50 + (int(percent) / 2))

    #
    # 函数：所有更新信息获取完成
    #
    def slot_access_completed(self, size_byte_o, size_byte_i, len_o, len_i, crucial_list):
        self.crucial_list = crucial_list
        # 没有任何更新
        if (len_o == 0 and len_i == 0 and len(crucial_list) == 0):
            #self.hide()
            self.set_default_sourceslist()
            if self.launch_mode == LaunchMode.MANUAL:
            #self.show_exit_widget(_("No software need updated"))
                self.loading_widget.change_layout.emit(_("No software need updated"))
                self.clean_sp_widget.emit()
            else:
                if self.click_cancel ==True:
                    self.loading_widget.change_layout.emit(_("No software need updated"))
                    self.clean_sp_widget.emit()
                #self.hide()
                else:
                    # self.exit_app("没有可用的更新.")
                    self.exit_app(_("No updated available."))
        else:
            self.app_num_ordinary = len_o
            self.app_num_important = len_i
            self.selected_num_ordinary = len_o
            self.selected_num_important = len_i
            self.size_ordinary = size_byte_o
            self.size_important = size_byte_i

            # 优先安装关键更新
            if (len(crucial_list) > 0):
                if (self.launch_mode == LaunchMode.AUTOMATIC):
                    # self.tray_icon.start_tray_msg("正在执行关键更新.")
                    self.tray_icon.start_tray_msg(_("Installing crucial update."))
                self.is_working_c = True
                self.iface.call_install_and_upgrade(crucial_list)

            if len_o > 0 and len_i > 0:
                self.change_display_content(LWMode.BOTH)
            elif len_o == 0 and len_i > 0:
                self.change_display_content(LWMode.IMPORTANT)
            elif len_o > 0 and len_i == 0:
                self.change_display_content(LWMode.ORDINARY)
            elif len_o == 0 and len_i == 0:
                # hide表示只有关键更新
                self.hide()

            print(_("Ordinary update : "), len_o, _(",Important update : "), len_i, _(",Crucial update : "),
                  len(crucial_list))

    #
    # 函数：显示继续扫描界面
    #
    def slot_change_layout(self, string):
        self.bottom_widget.hide()
        self.loading_widget.loadinglabel.hide()
        self.loading_widget.tiplabel.hide()
        self.loading_widget.errorlabel.show()
        self.loading_widget.errorlabel.move(155, 95)
        self.loading_widget.errorlabel.setText(string)
        self.loading_widget.cancel_btn.show()
        self.loading_widget.cancel_btn.move(315, 215)
        self.loading_widget.continue_btn.show()
        self.loading_widget.continue_btn.move(430, 215)
        self.loading_widget.setFixedSize(550,280)
        self.loading_widget.move(0,40)
        self.loading_widget.show()

    #
    #函数：清除sp列表
    #
    def slot_clean_spwidget(self):
        self.bottom_widget.sp_selection.clear()


    #
    # 函数：每获得一个app信息
    #
    def slot_get_one_app(self, msg):
        app_msg = AppMsg()
        app_msg.ZH_CN_NAME = msg["displayName"]
        app_msg.NAME = msg["name"]
        app_msg.ICON = msg["icon"]
        app_msg.SIZE = msg["downloadSizeHuman"]
        app_msg.BYTESIZE = msg["downloadSize"]
        app_msg.INSTALLEDVERSION = msg["installedVersion"]
        app_msg.CANDIDATEVERSION = msg["candidateVersion"]
        app_msg.DESCRIPTION = msg["description"]
        App_Version_dic = {'name': '', 'version': ''}
        App_Version_dic["name"] = app_msg.NAME
        App_Version_dic["version"] = app_msg.CANDIDATEVERSION
        self.App_Version_list.insert(self.App_install_num, App_Version_dic)
        self.App_install_num += 1
        if msg['apptype'] == AppType.ORDINARY:
            self.add_ordinary_item(app_msg)
        elif msg['apptype'] == AppType.IMPORTANT:
            self.add_important_item(app_msg)
        elif msg['apptype'] == AppType.SP:
            self.add_sp_item(app_msg)

    #
    #函数：添加SP包到UI界面
    #
    def add_sp_item(self, app_msg):
        is_SP_update = True
        item = QListWidgetItem()
        list_item = UpdateListItemWidget(app_msg, self)
        list_item.setFixedHeight(80)
        list_item.checkBox.hide()
        list_item.sizelabel.hide()
        list_item.logolabel.setFixedSize(48,48)
        list_item.logolabel.move(15,15)
        list_item.applabel.move(83,5)
        list_item.applabel.setStyleSheet("QLabel{font-size:18px;color:#444444;border:0px solid #cfcfcf;}")
        list_item.installed_versionlabel.setText(_("current version:")+app_msg.INSTALLEDVERSION)
        list_item.installed_versionlabel.setStyleSheet("QLabel{font-size:12px;color:#444444;border:0px solid #cfcfcf;}")
        list_item.installed_versionlabel.move(83,40)
        list_item.new_versionlabel.setText(_("new version:")+app_msg.CANDIDATEVERSION)
        list_item.new_versionlabel.setStyleSheet("QLabel{font-size:12px;color:#444444;border:0px solid #cfcfcf;}")
        list_item.new_versionlabel.move(83,57)
        list_item.splitlabel.hide()
        list_item.setStatusTip(str(app_msg.BYTESIZE))
        if "KYDROID" in app_msg.CANDIDATEVERSION.upper().split('-'):
            is_SP_update = False
            list_item.installed_versionlabel.hide()
            list_item.new_versionlabel.move(83, 45)
        item.setWhatsThis(app_msg.DESCRIPTION)
        self.bottom_widget.sp_selection.addItem(item)
        self.bottom_widget.sp_selection.setItemWidget(item, list_item)
        self.item_map[app_msg.NAME] = list_item
        self.get_app_num += 1
        self.change_display_content(LWMode.SP,is_SP_update)


    #
    # 函数：将一个普通app添加到ui
    #
    def add_ordinary_item(self, app_msg):
        item = QListWidgetItem()
        list_item = UpdateListItemWidget(app_msg, self)
        list_item.setStatusTip(str(app_msg.BYTESIZE))
        list_item.installed_versionlabel.hide()
        item.setWhatsThis(app_msg.DESCRIPTION)
        list_item.size_change.connect(self.recalculate_ordinary_apps_size)
        list_item.checkBox.clicked.connect(self.set_checkbox)
        self.bottom_widget.lw_all_selection.addItem(item)
        self.bottom_widget.lw_all_selection.setItemWidget(item, list_item)
        self.item_map[app_msg.NAME] = list_item
        #item.isSelected.connect(self.slot_select_item(app_msg))

    #
    # 函数：将一个重要app添加到ui
    #
    def add_important_item(self, app_msg):
        item = QListWidgetItem()
        list_item = UpdateListItemWidget(app_msg, self)
        list_item.setStatusTip(str(app_msg.BYTESIZE))
        list_item.installed_versionlabel.hide()
        item.setWhatsThis(app_msg.DESCRIPTION)
        list_item.size_change.connect(self.recalculate_important_apps_size)
        list_item.checkBox.clicked.connect(self.set_checkbox)
        self.bottom_widget.lw_all_selection.addItem(item)
        self.bottom_widget.lw_all_selection.setItemWidget(item, list_item)
        self.item_map[app_msg.NAME] = list_item
        self.get_app_num += 1
        #self.bottom_widget.lw_all_selection.itemClicked.connect(self.slot_select_item)
        '''
        update_item = QListWidgetItem()
        update_list_item = downloadwidget(app_msg,False,self)
        self.update_bottom_widget.lw_all_selection.addItem(update_item)
        self.update_bottom_widget.lw_all_selection.setItemWidget(update_item, update_list_item)
        
        '''


    #
    # 函数：ui内容初始化
    #
    def change_display_content(self, lw_mode , is_sp_update = False):
        #self.top_widget.label_all_num.setText(str(self.app_num_ordinary + self.app_num_important))
        self.bottom_widget.layout_h_cb.label_num.setText(str(self.get_app_num))
        self.update_bottom_widget.layout_h_cb.label_num.setText(str(self.app_num_ordinary + self.app_num_important))
        size_all_human = self.cu.byte_human(self.size_ordinary + self.size_important)

        if lw_mode == LWMode.BOTH:
            size_ordinary_human = self.cu.byte_human(self.size_ordinary)
            size_important_human = self.cu.byte_human(self.size_important)
            self.bottom_widget.lw_all_selection.setCurrentRow(0)
            first_item = self.bottom_widget.lw_all_selection.item(0)
            #self.bottom_widget.te_description.setText(first_item.whatsThis())
            self.bottom_widget.lw_all_selection.show()
            self.bottom_widget.layout_all_cb.label_cancel.hide()
            self.bottom_widget.layout_all_cb.cb.show()
            self.bottom_widget.layout_all_cb.label_3.hide()
            self.bottom_widget.layout_all_cb.label_all_select.show()
            self.bottom_widget.layout_h_cb.cb.show()
            self.bottom_widget.layout_h_cb.label_all_select.setText(_("totality "))
            self.bottom_widget.layout_h_cb.label_2.setText(_(" entries"))
            palette = QPalette()
            palette.setColor(QPalette.Background, QColor(255, 255, 255))
            self.bottom_widget.layout_all_cb.setPalette(palette)
            self.bottom_widget.show_both_title()
            self.show_main_window()
            self.switch_to_list_window()
        elif lw_mode == LWMode.IMPORTANT:
            size_important_human = self.cu.byte_human(self.size_important)
            self.bottom_widget.lw_all_selection.setCurrentRow(0)
            first_item = self.bottom_widget.lw_all_selection.item(0)
            #self.bottom_widget.te_description.setText(first_item.whatsThis())
            first_item.setSelected(False)
            self.bottom_widget.setFixedSize(550,560)
            self.bottom_widget.layout_all_cb.move(0,self.bottom_widget.height()-70)
            self.bottom_widget.lw_all_selection.show()
            self.bottom_widget.layout_all_cb.label_cancel.hide()
            self.bottom_widget.layout_all_cb.cb.show()
            self.bottom_widget.layout_all_cb.label_3.hide()
            self.bottom_widget.layout_all_cb.label_all_select.show()
            self.bottom_widget.layout_h_cb.cb.show()
            self.bottom_widget.layout_h_cb.label_all_select.setText(_("totality "))
            self.bottom_widget.layout_h_cb.label_2.setText(_(" entries"))
            palette = QPalette()
            palette.setColor(QPalette.Background, QColor(244, 244, 244))
            self.bottom_widget.layout_all_cb.setPalette(palette)
            self.bottom_widget.show_both_title()
            self.show_main_window()
            self.switch_to_list_window()
        elif lw_mode == LWMode.SP:
            #sp包升级时itemlist出现的地方
            self.bottom_widget.sp_selection.setCurrentRow(0)
            first_item = self.bottom_widget.sp_selection.item(0)
            first_item.setSelected(False)
            self.bottom_widget.resize(550,260)
            self.bottom_widget.sp_selection.show()
            # self.bottom_widget.te_description.setText(first_item.whatsThis())
            self.bottom_widget.show_both_title()
            self.bottom_widget.layout_all_cb.cb.hide()
            self.bottom_widget.layout_h_cb.cb.hide()
            self.bottom_widget.layout_all_cb.label_all_select.hide()
            self.bottom_widget.layout_all_cb.label_3.setText(_("Click the Cancel button,")+"\n"+_("system will check if there is any software  needs to update"))
            self.bottom_widget.layout_all_cb.label_3.show()
            if is_sp_update == False:
                self.bottom_widget.layout_h_cb.label_all_select.setText(_("An upgrade of an Android compatible package has been detected"))
            else:
                self.bottom_widget.layout_h_cb.label_all_select.setText(_("A new SP patch pack has been detected"))
            self.bottom_widget.layout_h_cb.label_num.setText("")
            self.bottom_widget.layout_h_cb.label_2.setText("")
            #self.bottom_widget.layout_all_cb.setAutoFillBackground(True)
            palette = QPalette()
            palette.setColor(QPalette.Background, QColor(255, 255, 255))
            self.bottom_widget.layout_all_cb.setPalette(palette)
            self.is_sp_update=True
            #self.show_main_window()
            self.switch_to_SP_window()

        else:
            size_ordinary_human = self.cu.byte_human(self.size_ordinary)
            self.bottom_widget.lw_all_selection.setCurrentRow(0)
            first_item = self.bottom_widget.lw_all_selection.item(0)
            #self.bottom_widget.te_description.setText(first_item.whatsThis())
            self.bottom_widget.show_both_title()
            self.show_main_window()
            self.switch_to_list_window()


    #
    # 函数：加减计算所选的普通升级包信息
    #
    def recalculate_ordinary_apps_size(self, size_str, flag):
        if flag:
            self.size_ordinary += long(size_str)
            self.selected_num_ordinary += 1
        else:
            self.size_ordinary -= long(size_str)
            self.selected_num_ordinary -= 1

        self.top_widget.label_selected_num.setText(str(self.selected_num_ordinary + self.selected_num_important))
        size_all_human = self.cu.byte_human(self.size_ordinary + self.size_important)
        self.top_widget.label_selected_size.setText(size_all_human)
        size_ordinary_human = self.cu.byte_human(self.size_ordinary)

    #
    # 函数：加减计算所选的重要升级包信息
    #
    def recalculate_important_apps_size(self, size_str, flag):
        if flag:
            self.size_important += long(size_str)
            self.selected_num_important += 1
        else:
            self.size_important -= long(size_str)
            self.selected_num_important -= 1

        size_all_human = self.cu.byte_human(self.size_ordinary + self.size_important)
        size_important_human = self.cu.byte_human(self.size_important)

    #
    # 函数：检查升级区域checkbox的状态
    #
    def set_checkbox(self):
        count = len(self.item_map)
        m = 0
        for item in self.item_map:
            curItem = self.item_map[item]
            if curItem.get_checkbox_status() == True:
                m += 1
        if m == 0:
            self.bottom_widget.layout_h_cb.cb.setCheckState(Qt.Unchecked)
            self.bottom_widget.layout_all_cb.cb.setCheckState(Qt.Unchecked)
        elif m == count:
            self.bottom_widget.layout_h_cb.cb.setCheckState(Qt.Checked)
            self.bottom_widget.layout_all_cb.cb.setCheckState(Qt.Checked)
        else:
            self.bottom_widget.layout_h_cb.cb.setCheckState(Qt.Unchecked)
            self.bottom_widget.layout_all_cb.cb.setCheckState(Qt.Unchecked)

    #
    # 函数：显示到前端
    #
    def show_to_frontend(self):
        if self.isMinimized() == True:
            self.showNormal()

        self.setWindowFlags(Qt.FramelessWindowHint | Qt.WindowStaysOnTopHint | Qt.Widget)
        self.show()
        self.raise_()

    #
    # 函数：重复运行程序
    #
    def single_work(self):
        if self.isHidden() == True:
            if self.launch_mode == LaunchMode.AUTOMATIC:
                self.exit_app()
            print "已经有一个程序在运行了."
            print(_("A daemon is already running."))
            # self.animation_msg_box.set_animation_args("已经有一个程序在运行了.", False)
            #self.animation_msg_box.set_animation_args(_("A daemon is already running."), False)
            #self.animation_msg_box.showAnimation(5000)
            #self.show_exit_widget(_("A daemon is already running."))
            self.signal_show_exit.emit(_("A daemon is already running."))
        else:
            self.show_to_frontend()

    #
    #函数：退出界面
    #
    def show_exit_widget(self,string):
        if self.launch_mode == LaunchMode.AUTOMATIC:
            self.exit_app()
        self.set_default_sourceslist()
        self.update_succuss_widget.tip_label.setText(string)
        self.update_succuss_widget.show()
        self.update_succuss_widget.move(self.x() + (self.width() - self.update_succuss_widget.width()) / 2,
                                        self.y() + (self.height() - self.update_succuss_widget.height()) / 2)
        self.exit_time.start(5000)

    #
    #函数：处理加载时改变加载界面的提示语
    #
    def slot_change_tiplabel(self,string,is_update_kum=False):
        if is_update_kum == False:
            self.loading_widget.tiplabel.setText(string)
        else:
            self.loading_widget.appname_label.show()
            self.loading_widget.label1.show()
            self.loading_widget.tiplabel.setText(string)
            self.loading_widget.appname_label.setText(_("Kylin Update Manager "))
            self.loading_widget.label1.setText(_("have a new version,Updating"))


    #
    # 函数：退出程序
    #
    def exit_app(self, msg=None):
        self.set_default_sourceslist()
        self.exit_time.stop()
        if self.iface:
            self.iface.exit_dbus()
        self.close()
        # if self.launch_mode == LaunchMode.AUTOMATIC:
        # os.system("sudo init 0")
        sys.exit(msg)


    #
    #函数：继续扫描
    #
    def slot_continue_scan(self):

        self.loading_widget.errorlabel.hide()
        self.loading_widget.continue_btn.hide()
        self.loading_widget.cancel_btn.hide()
        self.loading_widget.loadinglabel.show()
        self.loading_widget.tiplabel.show()
        #self.kus.at.quit_thread=True
        self.thread_work.start()

    #
    # 函数：退出程序和dbus后台
    #
    def exit_app_and_dbus(self, msg=None):
        if self.iface:
            self.iface.exit_dbus()
        self.close()

        sys.exit(msg)

    #
    #函数：切换到SP包升级界面
    #
    def switch_to_SP_window(self):
        self.loading_widget.show()
        self.move_to_center()
        self.show()
        self.sp_timer.start(1)


    #
    # 函数：切换到list界面
    #
    def switch_to_list_window(self):
        if self.launch_mode == LaunchMode.MANUAL:
        #self.loadingAnimation.start()
            self.bottom_widget.sp_selection.hide()
        self.loading_widget.show()
        self.move_to_center()
        self.timer.start(1)

    #
    #函数：处理切换到sp升级列表的动画
    #
    def slot_sptimer_timeout(self):
        self.sp_timer.stop()
        loadingwidget_width = self.loading_widget.width()
        loadingwidget_height = self.loading_widget.height()
        loadinglabel_width = self.loading_widget.loadinglabel.width()
        loadinglabel_height = self.loading_widget.loadinglabel.height()
        if loadingwidget_height-1 >0 and loadingwidget_width-2>0:
            self.loading_widget.setFixedSize(loadingwidget_width - 2, loadingwidget_height - 1)
            self.loading_widget.move((self.width() - loadingwidget_width - 2) / 2, (
                    self.height() - self.titlebar.height() - loadingwidget_height - 1) / 2 + self.titlebar.height())
            if self.loading_widget.loadinglabel.height() != 0:
                self.loading_widget.loadinglabel.resize(self.loading_widget.loadinglabel.width() - 10,
                                                        self.loading_widget.loadinglabel.height() - 1)
            self.sp_timer.start(4)
        if loadingwidget_width-2==0 or loadingwidget_height-1==0 or loadingwidget_width-2<0 or loadingwidget_height-1<0:
            self.loading_widget.hide()
            self.bottom_widget.show()


    #用于处理动画中主窗口变大
    #
    def slot_timeout(self):
        self.timer.stop()
        self.bottom_widget.layout_all_cb.move(0, self.height() - 70-60)
        #self.bottom_widget.lw_all_selection.hide()
        #self.bottom_widget.hide()
        self.move_to_center()
        loadingwidget_width = self.loading_widget.width()
        loadingwidget_height = self.loading_widget.height()
        loadinglabel_width = self.loading_widget.loadinglabel.width()
        loadinglabel_height = self.loading_widget.loadinglabel.height()
        #if self.launch_mode == LaunchMode.MANUAL:
        if self.width()<MAINWIDTH and self.height()+3<MAINHEIGHT :
            self.resize(self.width()+1, self.height()+3)
            self.titlebar.setFixedSize(self.width(), 40)
            self.titlebar.close_button.setGeometry(self.titlebar.width() - 34, 4, 30, 30)
            #self.loading_widget.show()
            if loadingwidget_height-1>=0 and loadingwidget_width-2>=0:
                self.loading_widget.setFixedSize(loadingwidget_width-2,loadingwidget_height-1)
                self.loading_widget.move((self.width()-loadingwidget_width-3)/2,(self.height()-self.titlebar.height()-loadingwidget_height)/2+self.titlebar.height())
                if self.loading_widget.loadinglabel.height() !=0:
                    self.loading_widget.loadinglabel.resize(self.loading_widget.loadinglabel.width()-10,self.loading_widget.loadinglabel.height()-1)
            self.move_to_center()
            self.timer.start(10)
        elif self.width()==MAINWIDTH and self.height()+3<=MAINHEIGHT:
            self.resize(self.width(), self.height() + 3)
            self.titlebar.setFixedSize(self.width(), 40)
            self.titlebar.close_button.setGeometry(self.titlebar.width()-34,4,30,30)
            self.titlebar.min_button.setGeometry(self.titlebar.width() - 68, 4, 30, 30)
            self.titlebar.set_button.setGeometry(self.titlebar.width() - 102, 4, 30, 30)
            if loadingwidget_height-2>=0 and loadingwidget_width-4>=0:
                self.loading_widget.resize(loadingwidget_width-6,loadingwidget_height-3)
                self.loading_widget.move((self.width()-loadingwidget_width-6)/2,(self.height()-self.titlebar.height()-loadingwidget_height-3)/2+self.titlebar.height())
                if loadingwidget_width - 6 == 0 or loadingwidget_height - 3 == 0 or loadingwidget_width - 6 < 0 or loadingwidget_height - 3 < 0:
                    self.loading_widget.hide()
                    #self.bottom_widget.show()
            self.titlebar.setGeometry(0,0,self.width(),40)
            self.move_to_center()
            self.timer.start(10)
        elif self.width()+1<MAINWIDTH and self.height()+3>=MAINHEIGHT:
            self.resize(self.width()+1, MAINHEIGHT)
            self.titlebar.setFixedSize(self.width(), 40)
            self.titlebar.close_button.setGeometry(self.titlebar.width() - 34, 4, 30, 30)
            self.titlebar.min_button.setGeometry(self.titlebar.width() - 68, 4, 30, 30)
            self.titlebar.set_button.setGeometry(self.titlebar.width() - 102, 4, 30, 30)
            if loadingwidget_height - 2 >= 0 and loadingwidget_width - 4 >= 0:
                self.loading_widget.resize(loadingwidget_width - 6, loadingwidget_height - 3)
                self.loading_widget.move((self.width() - loadingwidget_width - 6) / 2, (
                            self.height() - self.titlebar.height() - loadingwidget_height - 3) / 2 + self.titlebar.height())
                if loadingwidget_width - 6 == 0 or loadingwidget_height - 3 == 0 or loadingwidget_width - 6 < 0 or loadingwidget_height - 3 < 0:
                    self.loading_widget.hide()
                    # self.bottom_widget.show()
            self.titlebar.setGeometry(0, 0, self.width(), 40)
            self.move_to_center()
            self.timer.start(10)
        elif self.width()==MAINWIDTH and (self.height()+3>MAINHEIGHT or self.height()<MAINHEIGHT):
            self.resize(self.width(), MAINHEIGHT)
            self.titlebar.setFixedSize(self.width(), 40)
            self.loading_widget.hide()
            self.titlebar.close_button.setGeometry(self.titlebar.width() - 34, 4, 30, 30)
            self.titlebar.min_button.setGeometry(self.titlebar.width() - 68, 4, 30, 30)
            self.titlebar.min_button.show()
            self.titlebar.set_button.setGeometry(self.titlebar.width() - 102, 4, 30, 30)
            self.titlebar.set_button.show()
            self.bottom_widget.layout_h_cb.show()
            self.bottom_widget.lw_all_selection.show()
            self.bottom_widget.show()
            self.titlebar.setGeometry(0, 0, self.width(), 40)
            self.titlebar.setWindowOpacity(0)
            self.move_to_center()
        elif self.width()==MAINWIDTH and self.height()==MAINHEIGHT:
            self.resize(self.width(), MAINHEIGHT)
            self.titlebar.setFixedSize(self.width(), 40)
            self.loading_widget.hide()
            self.titlebar.close_button.setGeometry(self.titlebar.width() - 34, 4, 30, 30)
            self.titlebar.min_button.setGeometry(self.titlebar.width() - 68, 4, 30, 30)
            self.titlebar.min_button.show()
            self.titlebar.set_button.setGeometry(self.titlebar.width() - 102, 4, 30, 30)
            self.titlebar.set_button.show()
            self.bottom_widget.lw_all_selection.show()
            self.bottom_widget.show()
            self.titlebar.setGeometry(0, 0, self.width(), 40)
            self.titlebar.setWindowOpacity(0)
            self.move_to_center()
            #self.timer.start(5)
        #self.mainGroup.start()

    #
    # 函数：切换到详细界面
    #
    def switch_to_detail_window(self):
        self.update_bottom_widget.lw_all_selection.show()
        self.update_bottom_widget.show()
        self.bottom_widget.hide()


    #
    # 函数：窗口居中
    #
    def move_to_center(self):
        windowWidth = QApplication.desktop().screenGeometry(0).width()
        windowHeight = QApplication.desktop().screenGeometry(0).height()
        self.move((windowWidth - self.width()) / 2, (windowHeight - self.height()) / 2)
    #
    # 函数：显示主界面
    #
    def show_main_window(self):
        self.move_to_center()
        self.show()
        self.raise_()

    #
    # 函数：最小化界面
    #
    def slot_click_min_button(self):
        self.showMinimized()

    #
    # 函数：点击关闭
    #
    def slot_click_close_button(self):
        # 正在执行关键更新，点击关闭则hide主界面
        if self.is_working_c == True:
            self.hide()
        else:
            if self.is_working == True:
                # self.animation_msg_box.set_animation_args("更新未完成，请稍等.", False)
                self.animation_msg_box.set_animation_args(_("Updating, Please wait."), False)
                self.animation_msg_box.showAnimation(5000)
            else:
                self.set_default_sourceslist()
                self.exit_app()

    #
    # 函数：点击更新结束界面的关闭按钮
    #
    def slot_click_tip_close_button(self):
        self.exit_app()

    #
    # 函数：点击设置
    #
    #
    def slot_click_menu_button(self):
        self.get_pos.emit()
        if self.click_config == True:
            self.click_config = False
            self.menu.hide()

        else:
            self.click_config = True
            self.menu = menubar(self.width(), self.height(), self.x(), self.y(), self.iface, self)
            self.menu.move(338+self.x(),34+self.y())
            self.menu.time.start(0.2)
            self.menu.show()
            self.menu.clicked_btn_statue.connect(self.slot_handle_config_signal)
            self.menu.leave_btn.connect(self.slot_leave_menu_signal)
            self.get_pos.connect(self.get_point)

    # 函数:信号处理函数,点击了设置按钮
    def slot_handle_config_signal(self, re):
        if re == True:
            self.click_config = False

    def slot_leave_menu_signal(self):
        self.click_config = False
        self.menu.hide()

    # 获取鼠标的位置
    def get_point(self):
        x1 = self.titlebar.set_button.x()
        y1 = self.titlebar.set_button.y()
        w1 = self.titlebar.set_button.width()
        h1 = self.titlebar.set_button.height()
        x2 = self.menu.x()
        y2 = self.menu.y()
        w2 = self.menu.width()
        h2 = self.menu.height()
        x = QCursor.pos().x() - self.x()
        y = QCursor.pos().y() - self.y()
        if ((((x1 >= x) or (x1 + w1 <= x)) and ((x2 >= x) or (x2 + w2 <= x))) or (
                ((y1 >= y) or (y >= y1 + h1)) and ((y2 >= y) or (y2 + h2 <= y)))):
            self.menu.hide()
            self.click_config = False

    #
    #函数：处理down_finish信号
    #
    def slot_down_finish(self,down_done,_percent,appname):
        if appname not in self.crucial_list:
            percent=float(_percent)
            self.down_done=down_done
            self.down_num += 1
            if(self.down_done==True):
                i = 0
                while (i < self.get_app_num):
                    down_item = self.update_bottom_widget.lw_all_selection.item(i)
                    get_item_widget = self.update_bottom_widget.lw_all_selection.itemWidget(down_item)
                    if appname == "kylin-update-manager":
                        pass
                    else:
                        if (get_item_widget.app_msg.NAME == appname):
                            get_item_widget.progress.setValue(int(percent))
                            get_item_widget.sizelabel.setText(str(int(percent)) + "%")
                            break
                    i = i + 1

    #
    #函数：处理down_start信号
    #
    def slot_down_start(self,_percent,appname):
        if appname not in self.crucial_list:
            percent=float(_percent)
            i = 0
            while (i < self.get_app_num):
                down_item = self.update_bottom_widget.lw_all_selection.item(i)
                get_item_widget = self.update_bottom_widget.lw_all_selection.itemWidget(down_item)
                if appname == "kylin-update-manager":
                    pass
                else:
                    if (get_item_widget.app_msg.NAME == appname):
                        get_item_widget.progress.setValue(int(percent))
                        get_item_widget.sizelabel.setText(str(int(percent)) + "%")
                        break
                i = i + 1

    #
    #函数：处理apt_start信号
    #
    def slot_apt_start(self,_percent,appname):
        if appname not in self.crucial_list:
            percent=float(_percent)
            i=0
            while(i<self.get_app_num):
                install_item = self.update_bottom_widget.lw_all_selection.item(i)
                get_item_widget = self.update_bottom_widget.lw_all_selection.itemWidget(install_item)
                if appname == "kylin-update-manager":
                    pass
                else:
                    if(get_item_widget.app_msg.NAME==appname):
                        get_item_widget.progress.setValue(int(percent))
                        get_item_widget.tip_label.setText(_("installing"))
                        get_item_widget.sizelabel.setText(str(int(percent))+"%")
                        #get_item_widget.label_tips.setText("安装")
                        #get_item_widget.label_tips.setText(_("install"))
                        break
                            #print get_item_widget.app_msg.NAME
                i=i+1

    #
    #函数：处理apt_stop信号
    #
    def slot_apt_finish(self,num,appname):
        if appname not in self.crucial_list:
            self.install_num=num
            self.installed_app_num+=1
            i=0
            while(i<self.get_app_num):
                install_item = self.update_bottom_widget.lw_all_selection.item(i)
                get_item_widget = self.update_bottom_widget.lw_all_selection.itemWidget(install_item)
                if appname == "kylin-update-manager":
                    pass
                else:
                    if(get_item_widget.app_msg.NAME==appname):
                        get_item_widget.progress.setValue(100)
                        get_item_widget.sizelabel.setText("100%")
                        break
                i=i+1
            if self.installed_app_num==self.item_num:
                self.set_default_sourceslist()
            if appname== "kylin-update-desktop" or appname == "kylin-update-server":
                self.kylin_update_install_finish()
            if appname == "kylin-update-manager":
                self.kylin_update_manager_upgrade_finish()



    #
    # 函数：点击安装
    #
    def slot_click_install_button(self):
        if self.is_sp_update==True:
            i=0
            while (i<self.get_app_num):
                get_item = self.bottom_widget.sp_selection.item(i)
                get_item_widget = self.bottom_widget.sp_selection.itemWidget(get_item)

                self.work_list.append(get_item_widget.app_msg.NAME)
                self.item_num += 1
                update_item = QListWidgetItem()
                update_list_item = downloadwidget(get_item_widget.app_msg, True, self)
                update_list_item.checkBox.setCheckState(Qt.Checked)
                update_list_item.checkBox.hide()
                update_list_item.checkBox.setEnabled(False)
                update_list_item.logolabel.move(15,15)
                update_list_item.logolabel.setFixedSize(48,48)
                update_list_item.splitlabel.hide()
                self.update_bottom_widget.layout_h_cb.label_all_select.setText(_("Updating patch pack..."))
                self.update_bottom_widget.layout_h_cb.label_num.setText("")
                self.update_bottom_widget.layout_h_cb.label_2.setText("")
                self.update_bottom_widget.layout_all_cb.cb.hide()
                self.update_bottom_widget.layout_all_cb.label_all_select.hide()
                self.update_bottom_widget.layout_h_cb.cb.hide()
                self.update_bottom_widget.layout_all_cb.setAutoFillBackground(True)
                self.update_bottom_widget.lw_all_selection.addItem(update_item)
                self.update_bottom_widget.lw_all_selection.setItemWidget(update_item, update_list_item)
                palette = QPalette()
                palette.setColor(QPalette.Background, QColor(255, 255, 255))
                self.update_bottom_widget.layout_all_cb.setPalette(palette)
                self.update_bottom_widget.lw_all_selection.show()
                i += 1
        else:
            self.update_bottom_widget.layout_all_cb.cb.setCheckState(self.bottom_widget.layout_all_cb.cb.checkState())  #获取安装选择界面的cb状态用于设置安装界面的
            self.update_bottom_widget.layout_h_cb.cb.setCheckState(self.bottom_widget.layout_h_cb.cb.checkState())
            self.bottom_widget.lw_all_selection.show()
            self.update_bottom_widget.resize(550, 560)
            self.update_bottom_widget.lw_all_selection.resize(550, 490)
            self.update_bottom_widget.lw_all_selection.show()
            self.update_bottom_widget.layout_all_cb.label_cancel.hide()
            self.update_bottom_widget.layout_all_cb.move(0, self.update_bottom_widget.height() - 70)
            palette = QPalette()
            palette.setColor(QPalette.Background, QColor(244, 244, 244))
            self.update_bottom_widget.layout_all_cb.setPalette(palette)
            i = 0
            while (i<self.get_app_num):
                get_item = self.bottom_widget.lw_all_selection.item(i)
                get_item_widget = self.bottom_widget.lw_all_selection.itemWidget(get_item)
                if get_item_widget.get_checkbox_status():
                    self.work_list.append(get_item_widget.app_msg.NAME)
                    self.item_num += 1
                    update_item = QListWidgetItem()
                    update_list_item = downloadwidget(get_item_widget.app_msg, True, self)
                    update_list_item.checkBox.setCheckState(Qt.Checked)
                    update_list_item.checkBox.setEnabled(False)
                    self.update_bottom_widget.lw_all_selection.addItem(update_item)
                    self.update_bottom_widget.lw_all_selection.setItemWidget(update_item, update_list_item)
                else:
                    update_item = QListWidgetItem()
                    update_list_item = downloadwidget(get_item_widget.app_msg, False, self)
                    update_list_item.checkBox.setCheckState(Qt.Unchecked)
                    update_list_item.checkBox.setEnabled(False)
                    self.update_bottom_widget.lw_all_selection.addItem(update_item)
                    self.update_bottom_widget.lw_all_selection.setItemWidget(update_item, update_list_item)
                i+=1
            self.update_bottom_widget.layout_h_cb.label_all_select.setText(_("There are"))
            self.update_bottom_widget.layout_h_cb.label_num.setText(str(self.item_num))
            self.update_bottom_widget.layout_h_cb.label_2.setText(_("packages are being updated"))
        if self.work_list:
            self.is_working = True
            self.switch_to_detail_window()
            self.iface.call_install_and_upgrade(self.work_list)
        else:
            # self.animation_msg_box.set_animation_args("至少选择一个更新.", False)
            self.animation_msg_box.set_animation_args(_("Select one entry at least."), False)
            self.animation_msg_box.showAnimation(5000)

    #
    # 函数：点击取消
    #
    def slot_click_cancel_button(self):
        self.click_cancel = True
        self.get_app_num=0
        self.work_list=[]
        self.is_sp_update=False
        #self.bottom_widget.resize(MAINWIDTH,MAINHEIGHT-60)
        #self.bottom_widget.
        self.bottom_widget.sp_selection.hide()
        #self.kus.start_access()
        self.check_update_thread = Thread_check_update(self)
        self.check_update_thread.start()

    #
    #函数：点击SP包升级元素
    #
    def slot_click_sp_update_item(self,item):
        get_widget = self.bottom_widget.sp_selection.itemWidget(item)
        if self.firsttime_click_item == True:
            self.firsttime_click_item = False
            self.app_details = appdetails(get_widget.app_msg, self)
            self.app_details.top_widget.applogolabel.setFixedSize(48,48)
            self.app_details.top_widget.appnamelabel.move(75,17)
            self.app_details.top_widget.appversionlabel.move(75,45)
            self.app_details.move(self.x() + (self.width() - self.app_details.width()) / 2,
                                  self.y() + (self.height() - self.app_details.height()) / 2)
            self.app_details.show()
            self.app_details.is_show = True
        else:
            self.app_details.top_widget.applogolabel.clear()
            pixmap = QPixmap(get_widget.app_msg.ICON)
            if pixmap.isNull():
                pixmap = QPixmap("./res/soft_logo.png")
            self.app_details.top_widget.applogolabel.setPixmap(pixmap)
            self.app_details.top_widget.appnamelabel.clear()
            self.app_details.top_widget.appnamelabel.setText(get_widget.app_msg.NAME)
            self.app_details.top_widget.appversionlabel.clear()
            self.app_details.top_widget.appversionlabel.setText(_("version:") + get_widget.app_msg.CANDIDATEVERSION)
            self.app_details.descriplabel.clear()
            self.app_details.descriplabel.setText(get_widget.app_msg.DESCRIPTION)
            self.app_details.show()


    #
    # 函数：点击软件包升级元素
    #
    def slot_click_update_item(self, item):
        get_widget=self.bottom_widget.lw_all_selection.itemWidget(item)
        if self.firsttime_click_item==True:
            self.firsttime_click_item=False
            self.app_details=appdetails(get_widget.app_msg,self)
            self.app_details.move(self.x() + (self.width() - self.app_details.width()) / 2,
                                  self.y() + (self.height() - self.app_details.height()) / 2)
            self.app_details.show()
            self.app_details.is_show = True
        else:
            self.app_details.top_widget.applogolabel.clear()
            pixmap = QPixmap(get_widget.app_msg.ICON)
            if pixmap.isNull():
                pixmap = QPixmap("./res/soft_logo.png")
            self.app_details.top_widget.applogolabel.setPixmap(pixmap)
            self.app_details.top_widget.appnamelabel.clear()
            self.app_details.top_widget.appnamelabel.setText(get_widget.app_msg.NAME)
            self.app_details.top_widget.appversionlabel.clear()
            self.app_details.top_widget.appversionlabel.setText(_("version:")+get_widget.app_msg.CANDIDATEVERSION)
            self.app_details.descriplabel.clear()
            self.app_details.descriplabel.setText(get_widget.app_msg.DESCRIPTION)
            self.app_details.show()


    #
    # 函数：重置普通cb状态
    #
    def slot_reset_ordinary_cb(self, status):
        if status == 0:
            for item in self.item_map_ordinary:
                curItem = self.item_map_ordinary[item]
                curItem.checkBox.setCheckState(Qt.Unchecked)
        elif status == 2:
            for item in self.item_map_ordinary:
                curItem = self.item_map_ordinary[item]
                curItem.checkBox.setCheckState(Qt.Checked)

    #
    # 函数：重置cb状态
    #
    def slot_reset_cb(self, status):
        if status == 0:
            for item in self.item_map:
                curItem = self.item_map[item]
                curItem.checkBox.setCheckState(Qt.Unchecked)
        elif status == 2:
            for item in self.item_map:
                curItem = self.item_map[item]
                curItem.checkBox.setCheckState(Qt.Checked)

    #
    # 函数：重置重要cb状态
    #
    def slot_reset_important_cb(self, status):
        if status == 0:
            for item in self.item_map_important:
                curItem = self.item_map_important[item]
                curItem.checkBox.setCheckState(Qt.Unchecked)
        elif status == 2:
            for item in self.item_map_important:
                curItem = self.item_map_important[item]
                curItem.checkBox.setCheckState(Qt.Checked)

    #
    # 函数：实现无标题栏窗口拖动
    #
    def mousePressEvent(self, event):
        if (event.button() == Qt.LeftButton):
            self.get_pos.emit()
            self.mouse_press = True
            self.drag_pos = event.globalPos() - self.pos()
            event.accept()

    def mouseReleaseEvent(self, event):
        self.mouse_press = False
        self.setWindowOpacity(1)

    def mouseMoveEvent(self, event):
        if (self.mouse_press):
            self.move_pos = event.globalPos()
            self.move(self.move_pos - self.drag_pos)
            self.setWindowOpacity(0.9)
            event.accept()


def main():
    app = QApplication(sys.argv)
    QTextCodec.setCodecForTr(QTextCodec.codecForName("UTF-8"))
    QTextCodec.setCodecForCStrings(QTextCodec.codecForName("UTF-8"))

    globalfont = QFont()
    globalfont.setPixelSize(14)
    globalfont.setFamily("方正黑体_GBK")
    app.setFont(globalfont)

    app.setOrganizationName("Kylin")
    app.setOrganizationDomain("kylinos.cn")
    app.setApplicationName("kylin-update-manager")

    # 获取启动参数
    if (len(sys.argv) == 1):
        MainWindow(LaunchMode.MANUAL)
        sys.exit(app.exec_())
    elif (len(sys.argv) == 2):
        if (sys.argv[1] == "-m"):
            MainWindow(LaunchMode.MANUAL)
            sys.exit(app.exec_())
        elif (sys.argv[1] == "-auto"):
            MainWindow(LaunchMode.AUTOMATIC)
            sys.exit(app.exec_())
        else:
            # print "参数错误...", sys.argv
            print(_("Parameter Error..."), sys.argv)
    else:
        print(_("Parameter Error..."), sys.argv)


if __name__ == '__main__':
    main()
