#-*- coding:utf-8 -*-
from PyQt4.QtCore import *
from PyQt4.QtGui import *
from mainui.systembutton import *
from mainui.topwidget import *
import sys

import gettext
gettext.textdomain("kylin-update-manager")

_ = gettext.gettext

class appdetails(QWidget):
    def __init__(self,app_msg,parent=None):
        super(appdetails,self).__init__(parent)
        self.is_show=False
        self.app_msg=app_msg
        self.setWindowFlags(Qt.FramelessWindowHint | Qt.WindowStaysOnTopHint | Qt.Tool)
        palette = QPalette()
        palette.setColor(QPalette.Background, QColor(255, 255, 255))
        self.setPalette(palette)
        self.resize(450,320)
        self.initui()
        self.init_setStyleSheet()
        self.show()


    def initui(self):
        self.top_widget = TopWidget(self.app_msg,self)
        self.top_widget.setGeometry(0,0,450,80)
        self.top_widget.btn_close.clicked.connect(self.slot_close_button_clicked)
        self.top_widget.show()
        self.splitlabel = QLabel(self)
        self.splitlabel.setGeometry(0, 81, self.width(), 1)
        self.label_details = QLabel()
        self.label_details.setText(_("update details"))
        self.descriplabel = QTextEdit()
        self.descriplabel.setText(self.app_msg.DESCRIPTION)
        #self.descriplabel.setStyleSheet("QTextEdit{color:#4d6be5;ont-size:14px;}")
        self.descriplabel.resize(430,177)
        self.descriplabel.setReadOnly(True)
        self.descriplabel.setGeometry(0,80,0,0)

        hlayout1 = QHBoxLayout()
        hlayout1.addSpacing(15)
        hlayout1.addWidget(self.label_details)
        hlayout1.addStretch()

        hLayout2 = QHBoxLayout()
        hLayout2.addSpacing(15)
        hLayout2.addWidget(self.descriplabel)
        hLayout2.addSpacing(15)

        vlayout = QVBoxLayout()
        vlayout.addWidget(self.top_widget)
        vlayout.addSpacing(10)
        vlayout.addLayout(hlayout1)
        vlayout.addSpacing(10)
        vlayout.addLayout(hLayout2)
        vlayout.addSpacing(15)
        vlayout.setContentsMargins(0,0,0,0)
        self.setLayout(vlayout)

    def init_setStyleSheet(self):
        self.splitlabel.setStyleSheet("QLabel{background-color:#eff0ef;border:0px solid #cfcfcf;}")
        self.label_details.setStyleSheet("QLabel{color: #3d6be5;font-size:14px;}")
        #self.setStyleSheet(".QWidget{background-color:#ffffff;border-radius:6px;border:1px solid red;}")
        self.descriplabel.setStyleSheet("QTextEdit{border:0px solid #eff0ef;color:#444444;font-size:12px;}")
        self.descriplabel.verticalScrollBar().setStyleSheet("QScrollBar:vertical{margin:0px 0px 0px 0px;background-color:rgb(255,255,255,100);border:0px;width:6px;border-radius:6px;}\
                                                                     QScrollBar::sub-line:vertical{subcontrol-origin:margin;border:0px solid red;height:13px}\
                                                                     QScrollBar::up-arrow:vertical{subcontrol-origin:margin;background-color:rgba(0,0,0,0);height:13px}\
                                                                     QScrollBar::sub-page:vertical{background-color:#EEEDF0;}\
                                                                     QScrollBar::handle:vertical{background-color:rgba(0,0,0,20%);width:6px;border-radius:6px;}\
                                                                     QScrollBar::handle:vertical:hover{background-color:rgb(0,0,0,10%);opacity:0.1;width:6px;border-radius:6px;}\
                                                                     QScrollBar::handle:vertical:pressed{background-color:rgb(0,0,0,50%);width:6px;border-radius:6px;}\
                                                                     QScrollBar::add-page:vertical{background-color:#EEEDF0;}\
                                                                     QScrollBar::down-arrow:vertical{background-color:rgba(0,0,0,0);}\
                                                                     QScrollBar::add-line:vertical{subcontrol-origin:margin;border:0px solid green;height:13px}")
    #
    #函数：处理点击软件详情界面的关闭按钮
    #
    def slot_close_button_clicked(self):
        self.hide()

    # 鼠标点击、释放和移动事件
    def mousePressEvent(self, event):
        if (event.button() == Qt.LeftButton):
            self.mouse_press = True
            self.drag_pos = event.globalPos() - self.pos()
            event.accept()

    def mouseReleaseEvent(self, event):
        self.mouse_press = False
        self.setWindowOpacity(1)

    def mouseMoveEvent(self, event):
        if (self.mouse_press):
            self.move_pos = event.globalPos()
            self.move(self.move_pos - self.drag_pos)
            self.setWindowOpacity(0.9)
            event.accept()

