#!/usr/bin/python
# -*- coding: utf-8 -*-
from PyQt4.QtCore import *
from PyQt4.QtGui import *
from systembutton import CleanButton
import gettext
gettext.textdomain("kylin-update-manager")
_ = gettext.gettext

BUTTON_LEAVE=0
BUTTON_ENTER=1
BUTTON_PRESSED=2

class select_button(QPushButton):
    def __init__(self,btn_name="",is_update=False,parent=None):
        self.is_update=is_update
        super(select_button, self).__init__(parent)
        self.resize(100,40)
        self.setFocusPolicy(Qt.NoFocus)
        self.setText(btn_name)
        self.status = BUTTON_LEAVE
        if self.is_update==False:
            text = self.text()
            if text == _("Cancel") or text == _("quit"):
                self.setStyleSheet("QPushButton{border-radius:4px;background-color:#d9d9d9;color:#444444;font-size:16px;}")
            else:
                self.setStyleSheet("QPushButton{border-radius:4px;background-color:#3d6be5;color:#ffffff;font-size:16px;}")
        else:
            self.setDisabled(True)
            self.setStyleSheet("QPushButton{border-radius:4px;background-color:#e9e9e9;color:#c1c1c1;font-size:16px;}")

    #
    # 函数：鼠标进入事件
    #
    def enterEvent(self, event):
        self.status = BUTTON_ENTER
        if self.is_update==False:
            self.setStyleSheet("QPushButton{border-radius:4px;background-color:#6b8eeb;color:#ffffff;font-size:16px;}")
        else:
            self.setDisabled(True)
            self.setStyleSheet("QPushButton{border-radius:4px;background-color:#e9e9e9;color:#c1c1c1;font-size:16px;}")
        self.update()

    #
    # 函数：鼠标按下事件
    #
    def mousePressEvent(self, event):
        if (event.button() == Qt.LeftButton):
            self.mouse_press = True
            self.status = BUTTON_PRESSED
            if self.is_update==False:
                self.setStyleSheet("QPushButton{border-radius:4px;background-color:#4e5fc4;color:#ffffff;font-size:16px;}")
            else:
                self.setDisabled(True)
                self.setStyleSheet("QPushButton{border-radius:4px;background-color:#e9e9e9;color:#c1c1c1;font-size:16px;}")
            self.update()

    #
    # 函数：鼠标释放事件
    #
    def mouseReleaseEvent(self, event):
        if (self.mouse_press and self.rect().contains(event.pos())):
            self.mouse_press = False
            self.status = BUTTON_ENTER
            self.update()
            self.clicked.emit(True)

    #
    # 函数：鼠标离开事件
    #
    def leaveEvent(self, event):
        self.status = BUTTON_LEAVE
        if self.is_update==False:
            text=self.text()
            if text==_("Cancel") or text==_("quit"):
                self.setStyleSheet("QPushButton{border-radius:4px;background-color:#d9d9d9;color:#444444;font-size:16px;}")
            else:
                self.setStyleSheet("QPushButton{border-radius:4px;background-color:#3d6be5;color:#ffffff;font-size:16px;}")

        else:
            self.setDisabled(True)
            self.setStyleSheet("QPushButton{border-radius:4px;background-color:#e9e9e9;color:#c1c1c1;font-size:16px;}")
        self.update()

class allselectwidget(QWidget):
    tristate_status = 2
    click_main_cb = pyqtSignal(int)

    def __init__(self,width,hight,text1,text2="",text3="",text4="",is_update=False,need_button=False,parent=None):
        self.is_update=is_update
        super(allselectwidget,self).__init__(parent)
        self.setFixedSize(width,hight)
        self.setAutoFillBackground(True)
        palette = QPalette()
        palette.setColor(QPalette.Background, QColor(244, 244, 244))
        self.setPalette(palette)

        self.cb = CleanButton(self.is_update,self)
        self.cb.setCheckboxStatus(2)

        #self.cb.toggled.connect(self.slot_toggle_cb)
        #self.cb.setStyleSheet("{border-radius:6px;border:1px solid #cfcfcf;}")
        self.label_all_select = QLabel()

        #self.label_all_select.setFrameShape(QFrame.NoFrame)
        self.label_all_select.setText(text1)
        #self.label_all_select.resize(100,16)
        self.label_all_select.setStyleSheet("QLabel{color:#444444;font-size:14px;}")
        self.label_num = QLabel()
        self.label_num.setText(text2)
        self.label_num.setStyleSheet("QLabel{color:#f4812c;font-size:14px;font-weight:bold;}")
        self.label_2 = QLabel()
        self.label_2.setText(text3)
        self.label_2.setStyleSheet("QLabel{color:#444444;font-size:14px;}")

        self.label_3 = QLabel()
        self.label_3.setText(text4)
        self.label_3.setStyleSheet("QLabel{color:#444444;font-size:12px;}")
        self.label_3.hide()

        self.label_update = select_button(_("Update"),self.is_update,self)
        self.label_update.setFocusPolicy(Qt.NoFocus)
        self.label_update.setFixedSize(100,40)
        self.label_update.setGeometry(430,15,100,40)
        
        self.label_cancel = select_button(_("Cancel"),self.is_update,self)
        self.label_cancel.setFocusPolicy(Qt.NoFocus)
        self.label_cancel.setFixedSize(100, 40)
        self.label_cancel.setGeometry(318, 15, 100, 40)

        if need_button:
            self.label_update.show()
            self.label_cancel.show()
        else:
            self.label_update.hide()
            self.label_cancel.hide()
        if need_button==False:
            layout_h_cb = QHBoxLayout()
            layout_h_cb.addSpacing(5)
            layout_h_cb.addWidget(self.cb)
            layout_h_cb.setSpacing(15)
            layout_h_cb.addWidget(self.label_all_select)
            layout_h_cb.addWidget(self.label_num)
            layout_h_cb.addWidget(self.label_2)
            layout_h_cb.addStretch()
            layout_h_cb.addWidget(self.label_3)
        else:
            layout_h_cb = QHBoxLayout()
            layout_h_cb.addSpacing(5)
            layout_h_cb.addWidget(self.cb)
            layout_h_cb.setSpacing(15)
            layout_h_cb.addWidget(self.label_all_select)
            layout_h_cb.addWidget(self.label_num)
            layout_h_cb.addWidget(self.label_2)
            layout_h_cb.addStretch()
            layout_h_cb.addWidget(self.label_3)
            layout_h_cb.addSpacing(282)


        layout_v_cb = QVBoxLayout()
        layout_v_cb.addStretch()
        layout_v_cb.addLayout(layout_h_cb)
        layout_v_cb.addStretch()
        self.setLayout(layout_v_cb)

    #
    # 函数：获取cb状态
    #
    def get_checkbox_status(self):
        return self.checkBox.isChecked()
