#!/usr/bin/python
# -*- coding: utf-8 -*-

__author__ = 'wenbo'

import os
from PyQt4.QtGui import *
from PyQt4.QtCore import *
from switchbutton import SwitchBtn
from utils.enums import AUTOSTART,CRONDAILY
from systembutton import *
from titlebar import TitleBar
import  ConfigParser
import gettext
gettext.textdomain("kylin-update-manager")

_ = gettext.gettext


class ConfigWidget(QWidget):
    #
    # app_msg = None
    # size_change = pyqtSignal(str, bool)
    m_parent = None
    bootauto_check_file = pyqtSignal(bool)
    daily_check_file = pyqtSignal(bool)

    conf_path = "/usr/share/kylin-update-manager/kylin-update-manager.conf"
    def __init__(self, parent=None):
        # QWidget.__init__(self,parent)

        super(ConfigWidget,self).__init__(parent)
        self.setFixedSize(400, 300)
        self.parent = parent
        self.setWindowFlags(Qt.FramelessWindowHint|Qt.WindowStaysOnTopHint|Qt.Tool)
        palette = QPalette()
        palette.setColor(QPalette.Background, QColor(255, 255, 255))
        self.setPalette(palette)
        self.ui_init()
        self.stylesheet_init()

    #
    # 函数：初始化ui
    #
    def ui_init(self):
        self.setting_label=QLabel(self)
        self.setting_label.setFixedWidth(100)


        self.close_btn=SystemButton(False,False,True,self)
        self.close_btn.setGeometry(366,4,30,30)
        self.close_btn.clicked.connect(self.slot_click_close_button)

        self.btvalue_init()
        self.bootautocheckbt = SwitchBtn(self,initcheck=self.bootautocheckbt_initchecked) # 开机自动检测按钮
        self.dailycheckbt = SwitchBtn(self,initcheck=self.dailycheckbt_initchecked) # 每日定时检测按钮

        self.bootautochecklabel = QLabel(self)
        self.dailycheclabel = QLabel(self)


    #
    # 函数：初始化样式
    #
    def stylesheet_init(self):
        self.setting_label.setStyleSheet("QLabel{font-size:24px;color:#444444;}")
        self.setting_label.setText(_("setting"))
        self.setting_label.move(30,50)

        self.bootautochecklabel.setStyleSheet("QLabel{font-size:14px;color:#444444;}")
        self.bootautochecklabel.setText(_("Boot automatic detection"))
        self.bootautochecklabel.move(80,120)
        #self.bootautochecklabel.setGeometry(80,120,150,15)

        self.dailycheclabel.setStyleSheet("QLabel{font-size:14px;color:#444444;}")
        self.dailycheclabel.setText(_("Daily timing detection"))
        self.dailycheclabel.setGeometry(80,180,150,15)

        self.bootautocheckbt.setGeometry(240,120,50,24)

        self.dailycheckbt.setGeometry(240,180,50,24)


    #
    # 函数：初始化按钮状态
    #
    def btvalue_init(self):
        cf = ConfigParser.ConfigParser()
        cf.read(self.conf_path)
        bootauto=cf.get("Starting-mode","boot-auto")
        daily = cf.get("Starting-mode", "daily")
        print bootauto,daily
        #if(os.path.exists(AUTOSTART + "kylin-update-manager-autostart.desktop")):
        if(bootauto == "YES"):
            if (os.path.exists(AUTOSTART + "kylin-update-manager-autostart.desktop")):
                pass
            else:
                self.bootauto_check_file.emit(True)
            self.bootautocheckbt_initchecked = True

        else:
            self.bootautocheckbt_initchecked = False
        #else:
            #self.bootautocheckbt_initchecked = False
       # if(os.path.exists(CRONDAILY + "0kylin-update-manager-daily")):
        if(daily == "YES"):
            if (os.path.exists(CRONDAILY + "0kylin-update-manager-daily")):
                pass
            else:
                self.daily_check_file.emit(True)
            self.dailycheckbt_initchecked = True

        else:
            self.dailycheckbt_initchecked = False
        #else:
            #self.dailycheckbt_initchecked = False

    #
    # 函数：关闭按钮响应
    #
    def slot_click_close_button(self):
        self.hide()


    #
    # 函数：鼠标拖动窗口
    #
    def mousePressEvent(self, event):
        if(event.button() == Qt.LeftButton):
            self.mouse_press = True
            self.drag_pos = event.globalPos() - self.pos()
            event.accept()
    def mouseReleaseEvent(self, event):
        self.mouse_press = False
        self.setWindowOpacity(1)
    def mouseMoveEvent(self, event):
        if(self.mouse_press):
            self.move_pos = event.globalPos()
            self.move(self.move_pos - self.drag_pos)
            self.setWindowOpacity(0.9)
            event.accept()



