#!/usr/bin/python
# -*- coding: utf-8 -*-


from PyQt4.QtGui import *
from PyQt4.QtCore import *
from titlebar import TitleBar
import platform

import gettext
gettext.textdomain("kylin-update-manager")

_ = gettext.gettext

class DetailWidget(QWidget):

    def __init__(self, parent = None):
        super(DetailWidget,self).__init__(parent)

        self.setGeometry(0, 0, 336, 378)
        self.setWindowFlags(Qt.FramelessWindowHint)
        self.setAutoFillBackground(True)
        palette = QPalette()
        palette.setColor(QPalette.Background, QColor(234, 240, 243))
        self.setPalette(palette)

        if(platform.machine() == 'mips64'):
            self.MIPS64 = True
        else:
            self.MIPS64 = False

        #self.title_bar = TitleBar(self.width(), True, "正在更新", self)
        self.title_bar = TitleBar(self.width(),True, True, _("Updating"), self)
        self.title_bar.move(0, 0)
        self.title_bar.show()

        self.init_ui()
        self.init_style_sheet()
        self.init_text()

    #
    # 函数：初始化ui
    #
    def init_ui(self):
        self.label_pb_fetch = QLabel(self)
        self.label_pb_fetch.setGeometry(QRect(10, 40, 100, 17))
        self.label_pb_apt = QLabel(self)
        self.label_pb_apt.setGeometry(QRect(10, 88, 100, 17))
        self.label_desc = QLabel(self)
        self.label_desc.setGeometry(QRect(10, 140, 100, 17))

        self.pb_fetch = QProgressBar(self)
        self.pb_fetch.setGeometry(QRect(10, 63, 316, 19))
        self.pb_fetch.lower()
        self.pb_fetch.setValue(0)
        self.pb_apt = QProgressBar(self)
        self.pb_apt.setGeometry(QRect(10, 110, 316, 19))
        self.pb_apt.lower()
        self.pb_apt.setValue(0)

        self.te_detail = QTextEdit(self)
        self.te_detail.setReadOnly(True)
        self.te_detail.setGeometry(QRect(10, 160, 316, 208))

    #
    # 函数：初始化样式
    #
    def init_style_sheet(self):
        self.label_pb_fetch.setStyleSheet("QLabel{color:#666666;font-size:13px;}")
        self.label_pb_apt.setStyleSheet("QLabel{color:#666666;font-size:13px;}")
        self.label_desc.setStyleSheet("QLabel{color:#666666;font-size:13px;}")
        if(self.MIPS64):
            self.pb_fetch.setStyleSheet("QProgressBar{background-color:#ffffff;border:1px solid #aaaaaa;border-radius:0px;color:#666666;text-align:center;}")
            self.pb_apt.setStyleSheet("QProgressBar{background-color:#ffffff;border:1px solid #aaaaaa;border-radius:0px;color:#666666;text-align:center;}")
        else:
            self.pb_fetch.setStyleSheet("QProgressBar{background-color:#ffffff;border:1px solid #aaaaaa;border-radius:0px;color:#666666;text-align:center;}"
                                          "QProgressBar:chunk{background-color:#7acfff;}")
            self.pb_apt.setStyleSheet("QProgressBar{background-color:#ffffff;border:1px solid #aaaaaa;border-radius:0px;color:#666666;text-align:center;}"
                                          "QProgressBar:chunk{background-color:#b1dcff;}")
        self.te_detail.setStyleSheet("QTextEdit{background-color:#ffffff; border:1px solid #aaaaaa;font-size:13px;color:#666666;}")
        self.te_detail.verticalScrollBar().setStyleSheet("QScrollBar:vertical{margin:0px 0px 0px 0px;background-color:rgb(255,255,255,100);border:0px;width:6px;} \
                                                             QScrollBar::sub-line:vertical{subcontrol-origin:margin;border:1px solid red;height:13px} \
                                                             QScrollBar::up-arrow:vertical{subcontrol-origin:margin;background-color:blue;height:13px} \
                                                             QScrollBar::sub-page:vertical{background-color:#EEEDF0;} \
                                                             QScrollBar::handle:vertical{background-color:#D1D0D2;width:6px;} \
                                                             QScrollBar::handle:vertical:hover{background-color:#14ACF5;width:6px;} \
                                                             QScrollBar::handle:vertical:pressed{background-color:#0B95D7;width:6px;} \
                                                             QScrollBar::add-page:vertical{background-color:#EEEDF0;} \
                                                             QScrollBar::down-arrow:vertical{background-color:yellow;} \
                                                             QScrollBar::add-line:vertical{subcontrol-origin:margin;border:1px solid green;height:13px}")

    #
    # 函数：初始化文字
    #
    def init_text(self):
        #self.label_pb_fetch.setText("下载进度：")
        self.label_pb_fetch.setText(_("Download Process: "))
        #self.label_pb_apt.setText("安装进度：")
        self.label_pb_apt.setText(_("Install Process: "))
        #self.label_desc.setText("安装详情：")
        self.label_desc.setText(_("Install Details: "))
