#-*- coding:utf-8 -*-
from PyQt4.QtCore import *
from PyQt4.QtGui import *
from systembutton import *
from confwidget import *
from aboutwidget import *
from utils.enums import (BUTTON_ENTER, BUTTON_LEAVE, BUTTON_PRESSED, BUTTON_DISABLE)
from service.dbus_service import DbusService
from systembutton import *
import sys

import gettext
gettext.textdomain("kylin-update-manager")

_ = gettext.gettext

class menubar(QWidget):
    clicked_btn_statue = pyqtSignal(bool)
    leave_btn = pyqtSignal()
    enter_btn=pyqtSignal()
    m_parent=None
    clicked_btn=False

    conf_path = "/usr/share/kylin-update-manager/kylin-update-manager.conf"
    def __init__(self,width,height,x,y, iface, parent=None):
        self._width=width
        self._height=height
        self._x=x
        self._y=y
        self.status = BUTTON_ENTER
        self.time=QTimer()

        super(menubar, self).__init__(parent)
        self.m_parent=parent
        self.iface = iface
        #self.setAttribute(Qt.WA_TranslucentBackground)
        self.widget=QWidget(self)
        self.widget.setStyleSheet(".QWidget{border:1px solid #cfcfcf;}")
        self.setAutoFillBackground(True)
        palette = QPalette()
        palette.setColor(self.backgroundRole(), QColor(255, 255, 255))
        self.setPalette(palette)
        self.initui()
        self.init_connect()
        self.setGeometry(self._x+350, self._y+34, 140, 76)
        #self.init_stylesheet()
        self.show()

    def paintEvent(self,event):
        painter=QPainter(self)
        painter.setRenderHint(QPainter.Antialiasing)
        painter.setBrush(QBrush(Qt.white))
        painter.setPen(Qt.transparent)
        rect = self.rect()
        rect.setWidth(rect.width())
        rect.setHeight(rect.height())
        painter.drawRoundedRect(rect, 6, 6)

    def initui(self):
        self.setGeometry(self._x+350, self._y+34, 140, 76)
        self.widget.setGeometry(0, 0, self.width(), self.height())
        self.setWindowFlags(Qt.FramelessWindowHint|Qt.WindowStaysOnTopHint|Qt.Tool)
        #self.setAttribute(Qt.WA_TranslucentBackground,True)
        self.set_btn = listwidget(_("setting"),self)
        #self.set_btn.checkBox.hide()
        self.set_btn.move(4,4)
        self.about_btn = listwidget(_("about"),self)
        #self.about_btn.checkBox.hide()
        self.about_btn.move(4,40)
        #self.dark_color_btn = listwidget("深色模式",self)
        #self.light_color_btn = listwidget("浅色模式",self)
        #self.light_color_btn.checkBox.setCheckState(Qt.Checked)
        self.line_label1 = QLabel(self)
        self.line_label1.setFixedSize(132,1)
        self.line_label1.move(4,39)
        self.line_label1.setStyleSheet("QLabel{background-color:#eff0ef;border:1px solid #cfcfcf;}")
        '''
        self.btn_setting = QPushButton(self)
        self.btn_setting.setCursor(Qt.PointingHandCursor)
        self.btn_setting.setFocusPolicy(Qt.NoFocus)
        
        #当鼠标进入按钮时鼠标会变成手指头
        self.btn_setting.setCursor(QCursor(Qt.PointingHandCursor))
        self.btn_setting.setFixedSize(100,50)
        '''

    def additem(self,title=" "):
        item = QListWidgetItem()
        itemwidget = listwidget(title,self)
        self.itemlist.addItem(item)
        self.itemlist.setItemWidget(item,itemwidget)

    #
    #函数:初始化信号槽
    #
    def init_connect(self):
        #self.leave_btn.connect(self.mouse_leave_event)
        #self.enter_btn.connect(self.slot_enter_btn)
        #self.itemlist.itemClicked.connect(self.slot_click_item)
        self.about_btn.clicked_btn.connect(self.slot_clicked_btn)
        self.set_btn.clicked_btn.connect(self.slot_clicked_btn)
        self.about_btn.is_checked.connect(self.slot_clicked_btn)
        self.set_btn.is_checked.connect(self.slot_clicked_btn)
        #self.light_color_btn.clicked_btn.connect(self.slot_clicked_btn)
        #self.dark_color_btn.clicked_btn.connect(self.slot_clicked_btn)


    #
    #点击菜单中选项
    #
    def slot_clicked_btn(self,string):
        if (string == "设置") or(string=="setting"):
            self.slot_click_config_button()
        elif (string == "关于") or (string=="about"):
            self.slot_click_about_button()
        '''
        elif string=="浅色模式":
            if self.light_color_btn.checkBox.checkState()==Qt.Unchecked:
                self.light_color_btn.checkBox.setCheckState(Qt.Checked)
                self.dark_color_btn.checkBox.setCheckState(Qt.Unchecked)
        elif string=="深色模式":
            if self.dark_color_btn.checkBox.checkState()==Qt.Unchecked:
                self.dark_color_btn.checkBox.setCheckState(Qt.Checked)
                self.light_color_btn.checkBox.setCheckState(Qt.Unchecked)
        '''



    #
    #函数:点击设置按钮
    #
    def slot_click_config_button(self):
        self.clicked_btn=True
        self.clicked_btn_statue.emit(self.clicked_btn)
        self.config_widget=ConfigWidget(self)
        self.config_widget.bootauto_check_file.connect(self.on_bootautocheck_changed)
        self.config_widget.daily_check_file.connect(self.on_dailycheck_changed)
        self.config_widget.move(self._x+(self._width-self.config_widget.width())/2,self._y+(self._height-self.config_widget.height())/2)
        self.config_widget.show()
        self.config_widget.bootautocheckbt.checkedChanged.connect(self.on_bootautocheck_changed)
        self.config_widget.dailycheckbt.checkedChanged.connect(self.on_dailycheck_changed)
        self.hide()

    #
    #函数:点击关于按钮
    #
    def slot_click_about_button(self):
        self.clicked_btn=True
        self.clicked_btn_statue.emit(self.clicked_btn)
        self.about_widget=AboutWidget(self)
        self.about_widget.move(self._x+(self._width-self.about_widget.width())/2,self._y+(self._height-self.about_widget.height())/2)
        self.about_widget.show()
        self.hide()

    #函数：鼠标进入设置按钮
    def slot_enter_config(self):
        self.btn_setting.setStyleSheet("QPushButton{background-color:rgb(30,150,200);color:rgb(255,255,255);}")
        self.btn_about.setStyleSheet("QPushButton{background-color:rgb(15,132,180);color:rgb(255,255,255);}")

    #函数：鼠标进入关于按钮
    def slot_enter_about(self):
        self.btn_about.setStyleSheet("QPushButton{background-color:rgb(30,150,200);color:rgb(255,255,255);}")
        self.btn_setting.setStyleSheet("QPushButton{background-color:rgb(15,132,180);color:rgb(255,255,255);}")

    #函数：处理鼠标进入信号
    def slot_enter_btn(self):
        x=QCursor.pos().x()
        y=QCursor.pos().y()
        x=x-self.x()-self._x+self.btn_setting.x()
        y=y-self.y()-self._y+self.btn_setting.y()
        if ((self.btn_about.x()<=x)and(x<=(self.btn_about.x()+self.btn_about.width())))and((self.btn_about.y()<=y)and(y<=(self.btn_about.height()+self.btn_about.y()))):
            self.slot_enter_about()
        elif ((self.btn_setting.x()<=x)and(x<=(self.btn_setting.x()+self.btn_setting.width())))and((self.btn_setting.y()<=y)and(y<=self.btn_setting.y()+self.btn_setting.height())):
            self.slot_enter_config()
        else:
            self.btn_setting.setStyleSheet("QPushButton{background-color:rgb(15,132,180);color:rgb(255,255,255);}")
            self.btn_about.setStyleSheet("QPushButton{background-color:rgb(15,132,180);color:rgb(255,255,255);}")

    #鼠标进入事件
    def enterEvent(self, event):
        self.enter_btn.emit()

    #每隔0.2秒获取鼠标的位置
    def slot_get_pos_ontime(self):
        self.time.stop()
        self.enter_btn.emit()
        self.time.start(0.2)

    #
    # 函数：鼠标离开事件
    #
    def leaveEvent(self, event):
        self.status=BUTTON_LEAVE
        self.leave_btn.emit()


    #
    # 函数：鼠标按下事件
    #
    def mousePressEvent(self ,event):
        if event.button() == Qt.LeftButton:
            self.status=BUTTON_PRESSED
        else:
            event.ignore()

    #
    # 函数：鼠标释放事件
    #
    def mouseReleaseEvent(self ,event):
        if event.button() == Qt.LeftButton:
            #判断鼠标是否点击在这个按钮
            if self.rect().contains(event.pos()):
                self.status=BUTTON_ENTER
            else:
                self.status=BUTTON_LEAVE
        else:
            event.ignore()

    #函数：鼠标移动事件
    def mouseMoveEvent(self, event):
        if(self.status==BUTTON_PRESSED):
            self.leave_btn.emit()
            self.move_pos = event.globalPos()
            self.move(self.move_pos - self.drag_pos)
            self.setWindowOpacity(0.9)
            event.accept()

    #处理鼠标离开事件
    def mouse_leave_event(self):
        self.hide()

    def on_bootautocheck_changed(self,checked):
        cf = ConfigParser.ConfigParser()
        cf.read(self.conf_path)
        if checked :
            cf.set("Starting-mode","boot-auto","YES")
            self.iface.call_autostart_open()
        else:
            cf.set("Starting-mode", "boot-auto", "NO")
            self.iface.call_autostart_close()
        with open(self.config_widget.conf_path, "w+") as f:
            cf.write(f)

    def on_dailycheck_changed(self,checked):
        cf = ConfigParser.ConfigParser()
        cf.read(self.config_widget.conf_path)
        if checked :
            cf.set("Starting-mode", "daily","YES")
            self.iface.call_dailystart_open()
        else:
            cf.set("Starting-mode", "daily", "NO")
            self.iface.call_dailystart_close()
        with open(self.config_widget.conf_path, "w+") as f:
            cf.write(f)

class listwidget(QWidget):
    clicked_btn = pyqtSignal(str)
    is_checked = pyqtSignal(str)
    def __init__(self,title=" ",parent=None):
        super(listwidget, self).__init__(parent)
        self.statue=BUTTON_LEAVE
        self.time = QTimer()
        self.time.start(1)
        self.time.timeout.connect(self.slot_timeout)
        self.checkbox_statue = False
        self.title=title
        self.setAutoFillBackground(True)
        self.widget = QWidget(self)
        palette = QPalette()
        palette.setColor(self.backgroundRole(), QColor(255, 255, 255))
        self.setPalette(palette)
        self.setFixedSize(132,32)
        #self.widget.setGeometry(0,0,112,32)
        self.initui()
        self.styleSheet_init()

    def initui(self):
        self.checkBox = QCheckBox(self)
        self.checkBox.resize(16,16)
        self.titlelabel = QLabel(self)
        #self.titlelabel.setFixedSize(80,16)
        self.titlelabel.setStyleSheet("QLabel{font-size:14px;color:#444444;}")
        self.titlelabel.setText(self.title)

        hlayout=QHBoxLayout()
        hlayout.addSpacing(5)
        hlayout.addWidget(self.checkBox)
        hlayout.addSpacing(8)
        hlayout.addWidget(self.titlelabel)
        hlayout.addStretch()

        vlayout = QVBoxLayout()
        vlayout.addStretch()
        vlayout.addLayout(hlayout)
        vlayout.addStretch()
        vlayout.setContentsMargins(0, 0, 0, 0)
        self.setLayout(vlayout)

    def styleSheet_init(self):
        self.checkBox.setFocusPolicy(Qt.NoFocus)
        self.checkBox.setCheckState(Qt.Unchecked)
        self.checkBox.setStyleSheet("QCheckBox{border-radius:4px;border:1px solid #ffffff ;spacing: 0px;color:#FFFFFF}" \
                                    "QCheckBox:hover{background-color:#FFFFFF;}" \
                                    "QCheckBox::indicator{width: 16px;height: 16px;border-radius:4px;}" \
                                    "QCheckBox::indicator:unchecked{background-color:#FFFFFF;}" \
                                    "QCheckBox::indicator:unchecked:hover{background-color:#FFFFFF;}" \
                                    "QCheckBox::indicator:unchecked:pressed{background-color:#FFFFFF;border:0px solid #415FC4;}" \
                                    "QCheckBox::indicator{width: 16px;height: 16px;border-radius:4px;}" \
                                    "QCheckBox::indicator:checked{background-color:#FFFFFF;border:0px solid #415FC4;image: url(./res/check2);}" \
                                    "QCheckBox::indicator:checked:hover{background-color:#FFFFFF;border:0px solid #415FC4;image: url(./res/check2);}" \
                                    "QCheckBox::indicator:checked:pressed{background-color:#FFFFFF;border:0px solid #415FC4;image: url(./res/check2);}")

        #self.checkBox.connect(self.slot_toggle_cb)

    #
    #定时检查checkbox的状态
    #
    def slot_timeout(self):
        self.time.stop()
        checkbox_statue = self.checkBox.checkState()
        if checkbox_statue == Qt.Checked:
            string = self.titlelabel.text()
            self.is_checked.emit(string)
            self.checkBox.setCheckState(Qt.Unchecked)
        self.time.start(1)

    # 鼠标进入事件

    def enterEvent(self, event):
        self.status = BUTTON_ENTER


    #
    # 函数：鼠标离开事件
    #

    def leaveEvent(self, event):
        self.status = BUTTON_LEAVE

    #
    # 函数：鼠标按下事件
    #

    def mousePressEvent(self, event):
        if event.button() == Qt.LeftButton:
            self.status = BUTTON_PRESSED
            string=self.titlelabel.text()
            self.clicked_btn.emit(string)
        else:
            event.ignore()

    '''
    #
    # 函数：点击cb槽
    #
    def slot_toggle_cb(self):
        if self.checkBox.isChecked():
            self.size_change.emit(self.statusTip(), True)
        else:
            self.size_change.emit(self.statusTip(), False)
    '''




if __name__=="__main__":
    app=QApplication(sys.argv)
    s=menubar()
    sys.exit(app.exec_())
