#!/usr/bin/python
# -*- coding: utf-8 -*-

__author__ = 'lixiang'

import sys
reload(sys)
sys.setdefaultencoding('utf8')
from PyQt4.QtCore import *
from PyQt4.QtGui import *
from titlebar import TitleBar


class MessageWidget(QWidget):

    quitSignal = pyqtSignal()

    def __init__(self, content, flag = False, parent = None):
        super(MessageWidget,self).__init__(parent)
        self.resize(280, 90)
        self.flag = flag
        self.mouse_press = False
        self.setWindowFlags(Qt.FramelessWindowHint)
        self.title_bar = TitleBar(self.width(), False,False)
        self.label = QLabel()
        self.label.setAlignment(Qt.AlignCenter)
        # QLabel自动换行
        self.label.setWordWrap(True)
        self.label.setStyleSheet("background:#eaf0f3;color:#666666;font-size:14px;")
        self.label.setText(content)
        # self.label.setFixedWidth(240)
        main_layout = QVBoxLayout()
        main_layout.addWidget(self.title_bar)
        main_layout.addWidget(self.label)
        main_layout.setSpacing(0)
        main_layout.setContentsMargins(0, 0, 0, 0)
        self.setLayout(main_layout)
        self.title_bar.close_button.clicked.connect(self.slot_close_animation)
        # self.connect(self.title_bar, SIGNAL("closeWindow()"), self, SLOT("closeButtonClicked()"))
        self.hide()
        self.desktop = QApplication.desktop()
        self.timer = QTimer()
        self.animation = QPropertyAnimation(self,"pos")
        self.timer.timeout.connect(self.slot_close_animation)

    #
    # 函数：设置动画文字
    #
    def set_animation_args(self, showText, quitFlag):
        self.label.setText(showText)
        self.flag = quitFlag

    #
    # 函数：显示提示动画
    # display from right to left
    #
    def showAnimation(self, minutes):
        if self.isHidden():
            self.hide()
            if(self.timer.isActive()):
                self.timer.stop()
        self.move(self.desktop.availableGeometry().width(),self.desktop.availableGeometry().height() - self.height())
        self.show()
        self.animation.setDuration(1000)
        self.animation.setStartValue(QPoint(self.x(),self.y()))
        self.animation.setEndValue(QPoint((self.desktop.availableGeometry().width() - self.width()),(self.desktop.availableGeometry().height()-self.height())))
        self.animation.start()
        if(self.timer.isActive()):
            self.timer.stop()
        self.timer.start(minutes)

    #
    # 函数：结束提示动画
    # hide from left to right
    #
    def slot_close_animation(self):
        if(self.timer.isActive()):
            self.timer.stop()
        self.animation.setStartValue(QPoint(self.x(),self.y()))
        self.animation.setEndValue(QPoint(self.desktop.availableGeometry().width(), (self.desktop.availableGeometry().height()-self.height())))
        self.connect(self.animation, SIGNAL("finished()"), self.slot_close_widget)
        # self.connect(self.animation,SIGNAL("finished()"),self, SLOT("closeWidget()"))
        self.animation.start()

    #
    # 函数：关闭槽
    #
    def slot_close_widget(self):
        self.disconnect(self.animation, SIGNAL("finished()"), self.slot_close_widget)
        # self.disconnect(self.animation,SIGNAL("finished()"),self, SLOT("closeWidget()"))

        # flag为True时，弹出框消失后程序退出
        if self.flag == True:
            self.quitSignal.emit()
        else:
            self.hide()