#!/usr/bin/python
# -*- coding: utf-8 -*-

__author__ = 'lixiang'


from PyQt4.QtGui import *
from PyQt4.QtCore import *
from utils.enums import (BUTTON_ENTER, BUTTON_LEAVE, BUTTON_PRESSED, BUTTON_DISABLE)

class SystemButton(QPushButton):

    leave_btn = pyqtSignal(int)
    enter_btn = pyqtSignal(int)
    click_btn = pyqtSignal(int)

    def __init__(self,is_setingbtn,is_minibtn,is_closebtn, parent = None):
        super(SystemButton,self).__init__(parent)
        #self.setStyleSheet("QPushButton{border-radius:4px;background-color:#3d6be5;}")
        self.isclosebtn = is_closebtn
        self.issetingbtn=is_setingbtn
        self.isminibtn=is_minibtn
        self.setFocusPolicy(Qt.NoFocus)
        self.status = BUTTON_LEAVE
        self.setFixedSize(30, 30)
        self.click_btn.connect(self.paintbuttonevent)
        self.enter_btn.connect(self.paintbuttonevent)
        self.leave_btn.connect(self.paintbuttonevent)
        self.leave_btn.emit(0)


    #
    # 函数：鼠标进入事件
    #
    def enterEvent(self,event):
        self.enter_btn.emit(1)
        self.status = BUTTON_ENTER
        self.update()

    #
    # 函数：鼠标按下事件
    #
    def mousePressEvent(self,event):
        if(event.button() == Qt.LeftButton):
            self.mouse_press = True
            self.status = BUTTON_PRESSED
            self.update()

    #
    # 函数：鼠标释放事件
    #
    def mouseReleaseEvent(self,event):
        if(self.mouse_press and self.rect().contains(event.pos())):
            self.mouse_press = False
            self.click_btn.emit(2)
            self.status = BUTTON_ENTER
            self.update()
            self.clicked.emit(True)

    #
    # 函数：鼠标离开事件
    #
    def leaveEvent(self,event):
        self.leave_btn.emit(0)
        self.status = BUTTON_LEAVE
        self.update()

    #
    # 函数：绘图函数
    #
    def paintbuttonevent(self,mouse_statue=0):
        self.painter = QPainter()
        if mouse_statue==0:
            if self.isclosebtn:
                self.setStyleSheet("QPushButton{background-color:#ffffff;border-radius:4px;image: url(./res/close1);}")
            elif self.isminibtn:
                self.setStyleSheet("QPushButton{background-color:#ffffff;border-radius:4px;image: url(./res/mini1);}")
            else:
                self.setStyleSheet("QPushButton{background-color:#ffffff;border-radius:4px;image: url(./res/set1);}")
        elif mouse_statue==1:
            if self.isclosebtn:
                self.setStyleSheet("QPushButton{background-color:#f86457;border-radius:4px;image: url(./res/close2);}")
            elif self.isminibtn:
                self.setStyleSheet("QPushButton{background-color:#3d6be5;border-radius:4px;image: url(./res/mini2);}")
            else:
                self.setStyleSheet("QPushButton{background-color:#3d6be5;border-radius:4px;image: url(./res/set2);}")
        elif mouse_statue==2:
            if self.isclosebtn:
                self.setStyleSheet("QPushButton{background-color:#e44c50;border-radius:4px;image: url(./res/close2);}")
            elif self.isminibtn:
                self.setStyleSheet("QPushButton{background-color:#3257ca;border-radius:4px;image: url(./res/mini2);}")
            else:
                self.setStyleSheet("QPushButton{background-color:#3257ca;border-radius:4px;image: url(./res/set2);}")


class CleanButton(QCheckBox):

    clicked = pyqtSignal()
    buttonStatus = None
    tristateStatus = None

    def __init__(self,is_update=False,parent=None):
        super(CleanButton,self).__init__(parent)
        # self.status = BUTTON_LEAVE
        self.is_update=is_update
        self.init_ui()
        self.stylesheet_init()
        self.show()

    #
    # 函数：初始化ui
    #
    def init_ui(self):
        pixMap = QPixmap("./res/check.png")
        width = pixMap.width()
        height = pixMap.height()

        #
        # 函数：初始化样式
        #

    def stylesheet_init(self):
        if self.is_update==False:
            self.setFocusPolicy(Qt.NoFocus)
            self.setCheckState(Qt.Checked)
            self.setStyleSheet(
                "QCheckBox{border-radius:4px;spacing: 0px;color:#666666;font-size:14px;background-color:#FFFFFF;}" \
                "QCheckBox:hover{background-color:#DAE3FA;}" \
                "QCheckBox::indicator{width: 16px;height: 16px;border-radius:4px;}" \
                "QCheckBox::indicator:unchecked{background-color:#FFFFFF;border:1px solid #bfbfbf;}" \
                "QCheckBox::indicator:unchecked:hover{background-color:#DAE3FA;border:1px solid #6B8EEB;}" \
                "QCheckBox::indicator:unchecked:pressed{background-color:#BCCCF6;border:1px solid #415FC4;}" \
                "QCheckBox::indicator{width: 16px;height: 16px;border-radius:4px;}" \
                "QCheckBox::indicator:checked{background-color:#3D6BE5;border:1px solid #415FC4;image: url(./res/check);}" \
                "QCheckBox::indicator:checked:hover{background-color:#6B8EEB;border:1px solid #415FC4;image: url(./res/check);}" \
                "QCheckBox::indicator:checked:pressed{background-color:#415FC4;border:1px solid #415FC4;image: url(./res/check);}")
        else:
            self.setDisabled(True)
            self.setStyleSheet(
                "QCheckBox{border-radius:4px;spacing: 0px;color:#666666;font-size:14px;background-color:#FFFFFF;}" \
                "QCheckBox:hover{background-color:#DAE3FA;}" \
                "QCheckBox::indicator{width: 16px;height: 16px;border-radius:4px;}" \
                "QCheckBox::indicator:unchecked{background-color:#e9e9e9;border:1px solid #e0e0e0;}" \
                "QCheckBox::indicator:unchecked:hover{background-color:#e9e9e9;border:1px solid #e0e0e0;}" \
                "QCheckBox::indicator:unchecked:pressed{background-color:#e9e9e9;border:1px solid #e0e0e0;}" \
                "QCheckBox::indicator{width: 16px;height: 16px;border-radius:4px;}" \
                "QCheckBox::indicator:checked{background-color:#e9e9e9;border:1px solid #e0e0e0;image: url(./res/check);}" \
                "QCheckBox::indicator:checked:hover{background-color:#e9e9e9;border:1px solid #e0e0e0;image: url(./res/check);}" \
                "QCheckBox::indicator:checked:pressed{background-color:#e9e9e9;border:1px solid #e0e0e0;image: url(./res/check);}")

    #
    # 函数：设置按钮状态
    #
    def setCleanButtonStatus(self, status):
        self.buttonStatus = status
        if(self.buttonStatus==BUTTON_LEAVE)and(self.tristateStatus==2):
            self.setCheckState(Qt.Checked)
        elif(self.buttonStatus==BUTTON_LEAVE)and(self.tristateStatus==0):
            self.setCheckState(Qt.Unchecked)
        self.update()

    #
    # 函数：设置cb状态
    #
    def setCheckboxStatus(self, status):
        self.tristateStatus = status
        self.setCleanButtonStatus(BUTTON_LEAVE)

    #
    # 函数：鼠标按下事件
    #
    def mousePressEvent(self, event):
        if (event.button() == Qt.LeftButton):
            self.mouse_press = True
            self.clicked.emit()
            self.update()


if __name__ == '__main__':
   import sys
   app = QApplication(sys.argv)
   btn = SystemButton()
   btn.loadPixmap("../res/close_button.png")
   btn.show()
   sys.exit(app.exec_())