#!/usr/bin/python
# -*- coding: utf-8 -*-

from PyQt4.QtCore import *
from PyQt4.QtGui import *

from mainui.systembutton import *

import gettext
import sys

_=gettext.gettext

class UpdateSuccessWidget(QWidget):
    def __init__(self,parent=None):
        super(UpdateSuccessWidget,self).__init__(parent)
        self.setWindowFlags(Qt.FramelessWindowHint |Qt.WindowStaysOnTopHint|Qt.Tool)
        self.setFixedSize(300,200)
        self.setAutoFillBackground(True)
        palette = QPalette()
        palette.setColor(self.backgroundRole(), QColor(255,255,255))
        self.setPalette(palette)
        self.initui()
        #self.show()

    def initui(self):
        #self.topwidget=top_widget(self.width(),self)
        #self.topwidget.move(0,0)
        self.tip_label = QLabel()
        self.tip_label.resize(95, 22)
        self.tip_quit_label = QLabel()
        self.tip_quit_label.resize(125, 12)
        self.close_btn = SystemButton(False,False,True,self)
        self.close_btn.setGeometry(266,4,30,30)


        #显示更新成功
        self.tip_label.setText(_("update success"))
        self.tip_label.setStyleSheet("QLabel{color:#3D6BE5;font-size:24px;}")
        #程序将在5秒后退出
        self.tip_quit_label.setText(_("Program will exit in 5 seconds"))
        self.tip_quit_label.setStyleSheet("QLabel{color:#888888;font-size:14px}")

        hlayout1 = QHBoxLayout()
        hlayout1.addStretch()
        hlayout1.addWidget(self.tip_label)
        hlayout1.addStretch()

        hlayout2 = QHBoxLayout()
        hlayout2.addStretch()
        hlayout2.addWidget(self.tip_quit_label)
        hlayout2.addStretch()

        vlayout = QVBoxLayout()
        vlayout.addStretch()
        vlayout.addLayout(hlayout1)
        vlayout.addSpacing(15)
        vlayout.addLayout(hlayout2)
        vlayout.addStretch()

        self.setLayout(vlayout)

    #
    # 函数：鼠标按下事件
    #

    def mousePressEvent(self, event):
        if (event.button() == Qt.LeftButton):
            self.mouse_press = True
            self.drag_pos = event.globalPos() - self.pos()
            event.accept()

    def mouseReleaseEvent(self, event):
        self.mouse_press = False
        self.setWindowOpacity(1)

    def mouseMoveEvent(self, event):
        if (self.mouse_press):
            self.move_pos = event.globalPos()
            self.move(self.move_pos - self.drag_pos)
            self.setWindowOpacity(0.9)
            event.accept()

class top_widget(QWidget):
    def __init__(self,width,parent=None):
        super(top_widget,self).__init__(parent)
        self.setWindowFlags(Qt.FramelessWindowHint)
        self.setAutoFillBackground(True)
        self.resize(width,36)
        palette = QPalette()
        palette.setColor(self.backgroundRole(), QColor(255, 255, 255))
        self.setPalette(palette)
        self.initui()
        self.show()

    def initui(self):
        self.close_button = SystemButton(False,False,True,self)
        self.close_button.setGeometry(266,196,0,0)



