#!/usr/bin/python
# -*- coding: utf-8 -*-

__author__ = 'lixiang'

import os
from PyQt4.QtGui import *
from PyQt4.QtCore import *
from updateitem import Ui_UpdateItem

import gettext
gettext.textdomain("kylin-update-manager")

_ = gettext.gettext


class UpdateListItemWidget(QWidget):

    app_msg = None
    size_change = pyqtSignal(str, bool)

    def __init__(self, appmsg, parent=None):
        QWidget.__init__(self,parent)
        #self.resize(550, 70)
        self.setFixedSize(550,70)
        #self.setGeometry(0,0,550,70)
        self.setWindowFlags(Qt.FramelessWindowHint)
        self.app_msg = appmsg
        self.parent = parent
        self.ui_init()
        self.stylesheet_init()

    #
    # 函数：初始化ui
    #
    def ui_init(self):
        # self.setAutoFillBackground(True)
        # # self.setStyleSheet("QWidget{background:white}")
        # palette = QPalette()
        # palette.setColor(QPalette.Background, QColor(255,255,255))#ffffff
        # self.setPalette(palette)
        # self.show()
        self.checkBox = QCheckBox(self)
        self.checkBox.move(15,27)
        self.logolabel = QLabel(self)
        self.logolabel.setFixedSize(32, 32)
        self.logolabel.move(44,19)
        #self.logolabel.setGeometry(49,19,32,32)
        self.applabel = QLabel(self)
        self.applabel.setFixedWidth(240)
        self.applabel.move(90,17)
        #self.applabel.setGeometry(94,17,240,20)
        self.appdescribe = QLabel(self)
        self.appdescribe.setFixedWidth(240)
        self.appdescribe.move(90,45)
        #self.appdescribe.setGeometry(94,40,240,18)
        self.new_versionlabel = QLabel(self)
        self.new_versionlabel.setFixedWidth(210)
        self.new_versionlabel.move(355,27)
        self.installed_versionlabel = QLabel(self)
        self.installed_versionlabel.setFixedWidth(110)
        self.installed_versionlabel.move(355, 50)
        #self.new_versionlabel.setGeometry(359,27,110,16)
        self.sizelabel = QLabel(self)
        #self.sizelabel.setFixedSize(50,16)
        self.sizelabel.setFixedWidth(50)
        self.sizelabel.move(480,27)
        self.splitlabel = QLabel(self)
        self.splitlabel.setGeometry(0, 69, self.width(), 1)
        #self.splitlabel2 = QLabel(self)
        #self.splitlabel2.setGeometry(0, 0, self.width(), 1)

    #
    # 函数：初始化样式
    #
    def stylesheet_init(self):
        self.checkBox.setFocusPolicy(Qt.NoFocus)
        self.checkBox.setCheckState(Qt.Checked)
        self.checkBox.setStyleSheet("QCheckBox{border-radius:4px;spacing: 0px;color:#666666;font-size:14px;background-color:#FFFFFF;}" \
                                    "QCheckBox:hover{background-color:#DAE3FA;}" \
                                    "QCheckBox::indicator{width: 16px;height: 16px;border-radius:4px;}" \
                                    "QCheckBox::indicator:unchecked{background-color:#FFFFFF;border:1px solid #bfbfbf;}" \
                                    "QCheckBox::indicator:unchecked:hover{background-color:#DAE3FA;border:1px solid #6B8EEB;}" \
                                    "QCheckBox::indicator:unchecked:pressed{background-color:#BCCCF6;border:1px solid #415FC4;}" \
                                    "QCheckBox::indicator{width: 16px;height: 16px;}" \
                                    "QCheckBox::indicator:checked{background-color:#3D6BE5;border:1px solid #415FC4;image: url(./res/check);}" \
                                    "QCheckBox::indicator:checked:hover{background-color:#6B8EEB;border:1px solid #415FC4;image: url(./res/check);}" \
                                    "QCheckBox::indicator:checked:pressed{background-color:#415FC4;border:1px solid #415FC4;image: url(./res/check);}")
        pixmap = QPixmap(self.app_msg.ICON)
        if pixmap.isNull():
            pixmap = QPixmap("./res/soft_logo.png")
        self.logolabel.setPixmap(pixmap)
        self.logolabel.setAlignment(Qt.AlignHCenter | Qt.AlignVCenter)
        self.applabel.setStyleSheet("QLabel{font-size:16px;color:#444444;border:0px solid #cfcfcf;}")
        metrics = QFontMetrics(self.applabel.font())
        elidedText = metrics.elidedText(self.app_msg.NAME, Qt.ElideRight, self.applabel.width())
        if elidedText.endsWith("…"):
            #self.applabel.setToolTip(self.app_msg.NAME)
            self.applabel.setText(elidedText)
        else:
            self.applabel.setText(elidedText)

        self.judge_elidedText(self.appdescribe,self.app_msg.DESCRIPTION)
        self.appdescribe.setStyleSheet("QLabel{font-size:12px;color:#888888;border:0px solid #cfcfcf;}")
        self.sizelabel.setStyleSheet("QLabel{font-size:12px;color:#888888;border:0px solid #cfcfcf;}")
        self.sizelabel.setAlignment(Qt.AlignRight)
        self.sizelabel.setText(self.app_msg.SIZE)
        self.splitlabel.setStyleSheet("QLabel{background-color:#eff0ef;border:0px solid #cfcfcf;}")
        #self.splitlabel2.setStyleSheet("QLabel{background-color:#cfcfcf;border:0px solid #cfcfcf;}")
        self.judge_elidedText(self.new_versionlabel, self.app_msg.CANDIDATEVERSION)
        self.new_versionlabel.setStyleSheet("QLabel{font-size:12px;color:#444444;border:0px solid #cfcfcf;}")
        self.installed_versionlabel.setText(self.app_msg.INSTALLEDVERSION)
        self.installed_versionlabel.setStyleSheet("QLabel{font-size:12px;color:#444444;border:0px solid #cfcfcf;}")

        # self.connect(self.checkBox, SIGNAL("toggled(bool)"), self, SIGNAL("synCheckBoxState(bool)"))
        self.checkBox.toggled.connect(self.slot_toggle_cb)
        # self.connect(self.checkBox, SIGNAL("toggled(bool)"), self, SLOT("synItemContext()"))

    #
    #函数：用于超过大小用...代替
    #
    def judge_elidedText(self, label, str):
        metrics = QFontMetrics(label.font())
        elidedText = metrics.elidedText(str, Qt.ElideRight, label.width())
        if elidedText.endsWith("…"):
            #label.setToolTip(str)
            label.setText(elidedText)
        else:
            label.setText(elidedText)


    #
    # 函数：获取cb状态
    #
    def get_checkbox_status(self):
        return self.checkBox.isChecked()

    #
    # 函数：点击cb槽
    #
    def slot_toggle_cb(self):
        if self.checkBox.isChecked():
            self.size_change.emit(self.statusTip(), True)
        else:
            self.size_change.emit(self.statusTip(), False)
