#!/usr/bin/python
# -*- coding: utf-8 -*-

ICON_PATH = "/usr/share/ubuntu-kylin-software-center/data/icons/"


class UPackage:

    package = None
    displayName = None

    def __init__(self, pkg):
        self.package = pkg

    @property
    def name(self):
        return self.package.name

    @property
    def fullname(self):
        return self.package.fullname

    @property
    def icon(self):
        return ICON_PATH + self.name + ".png"

    @property
    def description(self):
        return self.package.candidate.description

    @property
    def summary(self):
       return self.package.candidate.summary

    @property
    def downloadSize(self):
        size = 0
        dep_list=[]
        try:
            size += self.package.candidate.size
            # print("wb111",self.package.candidate.dependencies)
            for dep in self.package.candidate.dependencies:
                if(dep.installed_target_versions):
                    if(dep.target_versions[0].version == dep.installed_target_versions[0].version): #系统已安装该版本依赖包
                        # print("wb222",dep.installed_target_versions,dep.target_versions[0].size)
                        pass
                elif(dep.target_versions):  # 动态计算需要安装的依赖包大小
                    size += dep.target_versions[0].size

            return size
        except:
            return size

    @property
    def downloadSizeHuman(self):
        size = self.downloadSize
        sizek = size / 1024
        if(sizek <= 1):
            return "1 KB"
        elif(sizek > 1 and sizek < 1024):
            return str(sizek) + " KB"
        else:
            return str('%.2f' % (sizek / 1024.0)) + " MB"

    @property
    def installedSize(self):
        try:
            return self.package.candidate.installed_size
        except:
            return 0

    @property
    def installedSizeHuman(self):
        size = self.installedSize
        sizek = size / 1024
        if(sizek <= 1):
            return "1 KB"
        elif(sizek > 1 and sizek < 1024):
            return str(sizek) + " KB"
        else:
            return str('%.2f' % (sizek / 1024.0)) + " MB"

    @property
    def installedVersion(self):
        if(self.package.installed is not None):
            return self.package.installed.version
        else:
            return " "

    @property
    def candidateVersion(self):
        try:
            return self.package.candidate.version
        except:
            return " "
