#!/usr/bin/python
# -*- coding: utf-8 -*-

from PyQt4.QtCore import SIGNAL

import gettext
gettext.textdomain("kylin-update-manager")
_ = gettext.gettext

VERSION = "v4.0"

INTERFACE = "cn.kylinos.KylinUpdateManager"
INTERFACES = "/cn/kylinos/KylinUpdateManager"
SINTERFACE = "cn.kylinos.KylinUpdateManager.singleton"
SINTERFACES = "/cn/kylinos/KylinUpdateManager/singleton"

AUTOSTART = "/etc/xdg/autostart/"
CRONDAILY = "/etc/cron.daily/"
STARTCONF = "/usr/share/kylin-update-manager/start.conf"

BUTTON_LEAVE = 0
BUTTON_ENTER = 1
BUTTON_PRESSED = 2
BUTTON_DISABLE = 3

LOADINGWIDTH = 550
LOADINGHEIGHT = 320
SPWIDTH=550
SPHEIGHT=320
MAINWIDTH = 550
MAINHEIGHT = 620
DETAILWIDTH = 336
DETAILHEIGHT = 378
RUNLIST = []


class LaunchMode:
    AUTOMATIC = "launch_mode_automatic"
    MANUAL = "launch_mode_manual"

class TaskMode:
    UPDATEKUM = "task_mode_updatekum"
    UPDATEOS = "task_mode_updateos"
    UPDATEPKG = "task_mode_updatepkg"

class LWMode:
    ORDINARY = "ordinary"
    IMPORTANT = "important"
    BOTH = "both"
    SP = "sp"

# 检测到的可用的升级媒介类型
class AUPSource:
    NOSOURCE = "no_source"
    DVDSOURCE = "dvd_source"
    FTPSOURCE = "ftp_source"
    HTTPSOURCE = "http_source"

class AppType:
    ORDINARY = "ordinary"
    IMPORTANT = "important"
    CRUCIAL = "crucial"
    SP = "sp"

class AptFunc:
    INIT = "init"
    GET_KYLIN_UPDATE = "get_kylin_update"
    GET_ALL_UPDATE = "get_all_update"

class Signals:
    update_source_cancel = SIGNAL("update-source-cancel")
    dbus_process_msg = SIGNAL("dbus-process-msg")
    get_kylin_update_over = SIGNAL("get_kylin_update_over")
    check_os_update_over = SIGNAL("check-os-update-over")
    start_tray_msg = SIGNAL("start-tray-msg")

class AppActions:
    INSTALLDEPS = "install_deps"
    INSTALLDEBFILE = "install_debfile"
    INSTALL = "install"
    REMOVE = "remove"
    UPGRADE = "upgrade"
    CANCEL = "cancel"
    APPLY = "apply_changes"
    PURCHASE = "purchase"
    UPDATE = "update"
    UPDATE_FIRST = "update_first"
    ADD_SOURCE = "add_source"
    REMOVE_SOURCE = "remove_source"
    GET_SOURCES = "get_sources"

#AptActionMsg = {
#    "install": "安装",
#    "upgrade": "更新",
#    "update": "源更新",
#}
AptActionMsg = {
    "install": _("install"),
    "upgrade": _("upgrade"),
    "update": _("update"),
}

#AptProcessMsg = {
#    "apt_start": "开始...",
#    "apt_finish": "完成!",
#    "apt_error": "失败!",
#    "apt_pulse": "进行中",
#    "down_start": "下载开始",
#    "down_stop": "下载完成",
#    "down_done": "下载",
#    "down_fail": "下载失败",
#    "down_fetch": "单项下载完成",
#    "down_pulse": "下载进行中...",
#    "down_cancel": "下载取消",
#}

AptProcessMsg = {
    "apt_start": _("start..."),
    "apt_finish": _("finish!"),
    "apt_error": _("failed!"),
    "apt_pulse": _("running"),
    "down_start": _("download start"),
    "down_stop": _("download complete"),
    "down_done": _("download"),
    "down_fail": _("download failed"),
    "down_fetch": _("download single entry complete"),
    "down_pulse": _("downloading..."),
    "down_cancel": _("download cancel"),
}

class AppMsg:
    ZH_CN_NAME = ""
    NAME = ""
    ICON = ""
    SIZE = ""
    BYTESIZE = 0
    INSTALLEDVERSION = ""
    CANDIDATEVERSION = ""
    DESCRIPTION = ""
